// Cpp2GamsCode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <cmath>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#define MaxNodes 88573
#define MaxYears 11
#define MaxStates 4
#define MaxLin 120
#define MaxTermLin 120
using namespace std ;
int main() {  /* start of the main program */
//
// declare scalars and arrays set up for a maximum of 10 years
//
static long I ; /* scalar for iterating through sets (arrays) using FOR/NEXT */
static long II ; /* second I scalar for iterating through sets (arrays) using FOR/NEXT */
static long III ; /* third I scalar for iterating through sets (arrays) using FOR/NEXT */
static long J ; /* scalar for iterating through sets (arrays) using FOR/NEXT */
static long K ; /* scalar for iterating through sets (arrays) using FOR/NEXT */ 
static long L ; /* the number of linearisations of each demand function */ 
static long M ; /* the number of linearisations in the terminal storage */ 
static long NS ; /* number (or card of the set) of contingent (probability) states */
static long S ; /* scalar (ord) used to loop over the set of contingent probability states */
static long NT ; /* number (or card of the set) of time periods (or stages) */ 
static long T ; /* scalar (ord) used to loop over the set of time periods */
static long TT ; /* second scalar (ord) used to loop over the set of time periods */
static long TTT ; /* third scalar (ord) used to loop over the set of time periods */
static long NScen ; /* Total number (card) of scenarios (leaves) in the decision tree */
static long NumScenYr[MaxYears] ; /* Number of forward scenarios for a node in each year */
static long CumNumScenYr[MaxYears] ; /* Cumulative number of forward scenarios for a node in each year */
static long NNodes ; /* Total number (card) of nodes in the decision tree, including root node */
static long count ; /* counter used to add up the total number of nodes */
static long D ; /* number of classes of demand for water */
static long nat[MaxYears] ; /* number of nodes at each time or stage */ 
static long cumnat[MaxYears] ; /* cumulative number of nodes at each time or stage */
static long StateAtNode[MaxNodes] ; /* contingent state for each node */
static long Nodes[MaxNodes] ; /* set (or ord) of nodes */ 
static long NodeTime[MaxNodes] ; /* time period in which node occurs */ 
static long NodeAT[MaxNodes] ; /* set (or ord) of nodes for each time period (stage) */ 
static long ChildNodeNumber[MaxStates][MaxNodes] ; /* Child node number */ 
static long ChildNodeTime[MaxStates][MaxNodes] ; /* Child node time */ 
static long ChildNodeNat[MaxStates][MaxNodes] ; /* Chile node number for its time period */ 
static long ParNodeNumber[MaxNodes] ; /* Parent node number */ 
static long ParNodeTime[MaxNodes] ; /* Parent node time */ 
static long ParNodeNat[MaxNodes] ; /* Parent node node number for its time period */
static double discount ; /* discount rate */
static double growth ; /* annual growth rate in demand */ 
static double EVinflow ; /* Expected value (mean) inflows per year (GL) */
static double utcdam ; /* Unit cost of delivering water through the distribution network ($M per GL) */
static double vcdam ; /* Unit cost of supplying water from dams ($M per GL) */
static double MaxS0 ; /* Initial storage capacity of dams (GL) */
static double MinS0 ; /* Initial minimum storage storage capacity of dams (GL) */
static double S0 ; /* Initial storage of water in dams (GL) */
static double EvapLoss ; /* Evaporative losses from storage (%) */
static double uvts ; /* unit value dam storage in the terminal year */
static double x ; /* parameter used to pass real double floating point arguments to math functions */
static double y ; /* parameter used to pass real double floating point arguments to math functions */
static double PriceUp ; /* Maximum price used for linearising the demand functions */
static double PriceLo ; /* Minimum price used for linearising the demand functions */
static double PriceLin[MaxLin] ; /* Price at each linearisation point [Max of 100 linearisation points] */
static double Df[MaxYears] ; /* Discount factor for each each */
static double gf[MaxYears] ; /* demand growth factor for each year */
static double alin[MaxStates] ; /* Constant (intercept) for the inverse demand curve ($M per GL 348) */ 
static double blin[MaxStates] ; /* Slope for the inverse demand curve */
static double bglin[MaxYears][MaxStates] ; /* Slope for the inverse demand curve adjusted for growth over time */
static double Alpha[MaxYears] ; /* Constant (intercept) for the inverse of the aggregated demand curve ($M per GL 348) */ 
static double Beta[MaxYears] ; /* Slope for the inverse of the aggregated demand curve adjusted for growth over time */
static double AreaQd[MaxNodes][MaxStates][MaxLin] ; /* Discount-probability weighted cumulative area under each linearised demand point */
static double QtyQd[MaxNodes][MaxStates][MaxLin]  ; /* Quantity demanded for each linearised demand point */
static double AggAreaQd[MaxNodes][MaxLin] ; /* Discount-probability weighted aggregated cumulative area under each linearised demand point */
static double AggQtyQd[MaxNodes][MaxLin]  ; /* Aggregate quantity demanded for each linearised demand point */
static double prob[MaxStates] ; /* Probability for each contingent state */ 
static double inflow[MaxStates] ; /* Inflow (GL/yr) for each contingent state */
static double Cr[MaxNodes] ; /* Conditional stochastic inlow for each node in each stage of the decision tree */
static double InfWght[MaxNodes] ; /* Inlow weight for each node in each stage of the decision tree */
static double CumR[MaxNodes] ; /* Cumulative conditional stochastic inlow for each node in each stage of the decision tree */
static double Cp[MaxNodes] ;  /* Conditional probability for each node in each stage of the decision tree */
static double P[MaxNodes] ; /* Probability for each node in each stage of the decision tree */
static double VarCostDam[MaxNodes] ; /* Discount-probability cost of operating dams */
static double TermStorArea[MaxNodes][MaxTermLin] ; /* Discount-probability price of NSW from storage in the terminal period */
static double QtySt[MaxTermLin] ; /* Quantity of water in storage in the terminal period */
static double Aterm ; /* A(x^b) for the terminal condition */
static double bterm ; /* A(x^b) for the terminal condition */
/* Demand calibration */
static double Pt ; /* Price point for calibrating the demand curve for a given arc elasticity */
static double Qt ; /* Quantity point for calibrating the demand curve for a given arc elasticity */
static double Pi ; /* Initial price for calibrating the demand curve for a given arc elasticity */
static double Pf ; /* Final price for calibrating the demand curve for a given arc elasticity */
static double Qi[MaxStates] ; /* Initial price for calibrating the demand curve for a given arc elasticity */
static double Qf[MaxStates] ; /* Final price for calibrating the demand curve for a given arc elasticity */
static double Arc[MaxStates] ; /* Final price for calibrating the demand curve for a given arc elasticity */
static double ShareQt[MaxStates] ; /* Share of demand type in total Qt */
/* Indoor = 1; Outdoor = 2; Commercial = 3 */
Pi = 1 ;
Pf = 5 ;
Pt = 1.5 ;
Qt = 370*1.1 ;
D = 3 ;
ShareQt[1] = 0.59 ;
ShareQt[2] = 0.30 ;
ShareQt[3] = 0.11 ;
Arc[1] = -0.1 ; // +- 0.05
Arc[2] = -0.3 ; // +- 0.1
Arc[3] = -0.3 ;

for (I=1; I<=D; I++){
  Qi[I] = ShareQt[I]*Qt*(Pf-Pi)*(Pf+Pi-Arc[I]*(Pf-Pi))
	    /
		((Pt-Pi)*(Pf+Pi+Arc[I]*(Pf-Pi))-(Pt-Pf)*(Pf+Pi-Arc[I]*(Pf-Pi))) ;

  Qf[I] = Qi[I]*(Pf+Pi+Arc[I]*(Pf-Pi))
	    /
		(Pf+Pi-Arc[I]*(Pf-Pi)) ;

  blin[I] = (Pf-Pi)/(Qf[I]-Qi[I]) ;
  alin[I] = Pi - blin[I]*Qi[I] ;
} ;
/* Terminal condition calibration */
//Aterm = 150.65 ;
//bterm = -0.8098 ;
Aterm = 1221.6 ;
bterm = -1.1364 ;

/* Long-run marginal cost related parameters for set generation */
static long start_block /* The initial pricing block appropriate for the first node in a year */ ;
static long total_block /* The running cumulative total of pricing blocks */ ;
static long bcount /* Counter used for totalling blocks */ ;
static long block /* The block appropriate for the current YrNd */ ;
static long block_length /* The period after which long-run marginal cost is recalibrated */ ;
/* Initialisation */
start_block = 0 ;
bcount = 1 ;
block_length = 4 ;
/* streams */
ofstream NdPrBlk("NdPrBlk.gms") ;  // Set NdPrBlk(Yr,N,PrBlk) Mapping nodes to blocks //
  NdPrBlk <<"Set NdPrBlk(Yr,N,PrBlk) mapping between N and price blocks " <<endl ; // declare the mapping NdPrBlk //



//
// Open CreateGamsCode.lst file to write a log of time taken for the task
//
ofstream CreateGamsCode("CreateGamsCode.lst") ;  
  clock_t StartTime, EndTime ;
  StartTime = clock() ;
  CreateGamsCode <<"Start time = " << StartTime/CLK_TCK << endl ;
//
// define the initial dimensions of the scenario and contingent states and relevant data
//
NT = 10 ;
if (NT > MaxYears - 1) {
  cout << NT << " is too many years. The maximum allowed is " << MaxYears-1 << endl ;
  return(0) ;
} ;
NS = 3 ;
if (NS > MaxStates - 1) {
  cout << NS << " is too many states. The maximum allowed is " << MaxStates-1 << endl ;
  return(0) ;
} ;
L = 15 ; /* The number of linearisations of each demand function */
if (L > MaxLin - 1) {
  cout << L << " is too many linear segments. The maximum allowed is " << MaxLin-1 << endl ;
  return(0) ;
} ;
M = 15 ; /* The number of linearisations in the terminal storage */
if (M > MaxTermLin - 1) {
  cout << M << " is too many linear segments. The maximum allowed is " << MaxTermLin-1 << endl ;
  return(0) ;
} ;

prob[1] = 0.2497 ; /* contingent state 1 */
prob[2] = 0.5547 ;  /* contingent state 2 */
prob[3] = 0.1956 ; /* contingent state 3 */
inflow[1] = 0.594262959 ; /* contingent state 1 */
inflow[2] = 1.009483301 ; /* contingent state 2 */
inflow[3] = 1.529783953 ; /* contingent state 3 */
EVinflow = 373.5619 ;

discount = 0.06 ;
growth = 0.016 ;
utcdam = 0.35 ;
vcdam = 0.1 ;
MaxS0 = 1812 ;
MinS0 = 0.1*MaxS0 ;
S0 = 0.35*MaxS0 ;
EvapLoss = 0.0 ;
uvts = 2.0 ;

PriceLo = vcdam + utcdam ;
PriceUp = 999999 ;
for (I=1; I<=D; I++){
  if (alin[I] < PriceUp){
    PriceUp = alin[I] ;
  } ;
} ;
for (I=1; I<=L; I++) { 
  PriceLin[I] = PriceUp - double(I)*(PriceUp - PriceLo)/double(L) ;
} ;

/* Desal specific investment parameters for calculations */
static long DesalInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
DesalInvLag = 3 ; /* Lag on the investment */
static long desallife ; /* life of plant (years) */
desallife = 27.7 ; /* Life of a plant in years */
static double vcdesal ; /* Unit cost of supplying water ($M per GL) */
vcdesal = 1.09 ;
static double DesalInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
DesalInvC =  1016*5 ; /* $m for plant of UnitSize rated capacity */
static double DesalMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
DesalMainC =  0.784*5 ; /* $m for plant of UnitSize rated capacity */
static double DesalUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
DesalUnitSize = 250 ;
static long DesalIcap ; /* maximum capacity (GL) */
DesalIcap = 1 ; /* Maximum total installed capacity across all plants */
static double TrdesalInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostDesal[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostDesal[MaxNodes] ; /* Discount-probability capital cost of building */
/* End desal parameters */

/* Aquifer specific investment parameters for calculations */
static long AquifInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
AquifInvLag = 5 ; /* Lag on the investment */
static long aquiflife ; /* life of plant (years) */
aquiflife = 50 ; /* Life of a plant in years */
static double vcaquif ; /* Unit cost of supplying water ($M per GL) */
vcaquif = 1.04 ;
static double AquifAdStCap ; /* Additional storage capacity (GL) */
AquifAdStCap = 500 ;
static double AquifInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
AquifInvC =  773 ; /* $m for plant of UnitSize rated capacity */
static double AquifMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
AquifMainC =  36.9 ; /* $m for plant of UnitSize rated capacity */
static double AquifUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
AquifUnitSize = 86 ;
static long AquifIcap ; /* maximum capacity (GL) */
AquifIcap = 1 ; /* Maximum total installed capacity across all plants */
static double TraquifInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostAquif[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostAquif[MaxNodes] ; /* Discount-probability capital cost of building */
static double AquifSC[MaxNodes] ; /* Aquifer supply capacity for each node in each stage of the decision tree */
/* End aquifer parameters */

/* Recycling specific investment parameters for calculations */
static long RecycInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
RecycInvLag = 3 ; /* Lag on the investment */
static long recyclife ; /* life of plant (years) */
recyclife = 27.7 ; /* Life of a plant in years */
static double vcrecyc ; /* Unit cost of supplying water ($M per GL) */
vcrecyc = 1.5 ;
static double RecycInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
RecycInvC =  2200 ; /* $m for plant of UnitSize rated capacity */
static double RecycMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
RecycMainC =  22 ; /* $m for plant of UnitSize rated capacity */
static double RecycUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
RecycUnitSize = 70 ;
static long RecycIcap ; /* maximum capacity (GL) */
RecycIcap = 1 ; /* Maximum total installed capacity across all plants */
static double TrrecycInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostRecyc[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostRecyc[MaxNodes] ; /* Discount-probability capital cost of building */
/* End recycling parameters */

/* Tanks specific investment parameters for calculations */
static long TanksInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
TanksInvLag = 1 ; /* Lag on the investment */
static long tankslife ; /* life of plant (years) */
tankslife = 30 ; /* Life of a plant in years */
static double vctanks ; /* Unit cost of supplying water ($M per GL) */
vctanks = 0.05 ;
static double TanksInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
TanksInvC =  2300 ; /* $m for plant of UnitSize rated capacity */
static double TanksMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
TanksMainC =  20 ; /* $m for plant of UnitSize rated capacity */
static double TanksUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
TanksUnitSize = 29 ;
static long TanksIcap ; /* maximum capacity (GL) */
TanksIcap = 1 ; /* Maximum total installed capacity across all plants */
static double TrtanksInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostTanks[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostTanks[MaxNodes] ; /* Discount-probability capital cost of building */
static double TanksSC[MaxNodes] ; /* Tanks supply capacity for each node in each stage of the decision tree */
/* End tanks parameters */

/* Trade specific investment parameters for calculations */
static long TradeInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
TradeInvLag = 3 ; /* Lag on the investment */
static long tradelife ; /* life of plant (years) */
tradelife = 50 ; /* Life of a plant in years */
static double vctrade ; /* Unit cost of supplying water ($M per GL) */
vctrade = 0.70 ;
static double TradeInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
TradeInvC =  750*1.33 ; /* $m for plant of UnitSize rated capacity */
static double TradeMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
TradeMainC =  7.5*1.33 ; /* $m for plant of UnitSize rated capacity */
static double TradeUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
TradeUnitSize = 100 ;
static long TradeIcap ; /* maximum capacity (GL) */
TradeIcap = 1 ; /* Maximum total installed capacity across all plants */
static double TrtradeInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostTrade[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostTrade[MaxNodes] ; /* Discount-probability capital cost of building */
static double TradePr[MaxStates] ; /* Trade price for each contingent state */
TradePr[1] = 0.7 ; /* contingent state 1 */
TradePr[2] = 0.48 ; /* contingent state 2 */
TradePr[3] = 0.25 ; /* contingent state 3 */
static double TradePrNd[MaxNodes] ; /* Inlow weight for each node in each stage of the decision tree */
/* End trade parameters */


static double LRAICdesal ; /* LRAIC of supply from desal used as the imputed price for storage in the terminal period */
LRAICdesal = DesalInvC/DesalUnitSize*discount/(1.0-pow(1.0/(1.0+discount),desallife)) + DesalMainC/DesalUnitSize + vcdesal + utcdam ;


uvts = LRAICdesal - utcdam - vcdam ;
uvts = 1.64 ; /* TERMINAL PRICE TIM ***** */


//
// compute the number of scenarios and nodes
//
NScen = long(powl(NS, NT)) ;
NNodes = (long(powl(NS,NT+1))-NS)/(NS-1) ;
CreateGamsCode <<"NScen = " << NScen << endl ;
CreateGamsCode <<"NNodes = " << NNodes << endl ;
//
// open each GAMS file being created and declare the contents (set or parameter)
//
ofstream Sets("Sets.gms") ;  // Sets definitions //
  Sets <<"Set Yr time periods / Yr1*Yr" << NT << " / ;" <<endl ; // declare set Yr
  Sets <<"  Alias(Yr,YrP,YrPP) ;" << endl ; // declare alias for set Yr
  Sets <<"Set N  all nodes in the decision tree / N1*N" << NNodes << " / ;" <<endl ; // declare set Yr
  Sets <<"  Alias(N,NP,NPP) ;" << endl ; // declare alias for set N
  Sets <<"Set S maximum set of contingent states in any time period / s1*s" << NS << " / ;" <<endl ; // declare set S
  Sets <<"Set L linearised points for demand functions / L1*L" << L << " / ;" <<endl ; // declare set L
  Sets <<"Set M linearised points for terminal storage / M1*M" << M << " / ;" <<endl ; // declare set M
  Sets <<"Set D Users in the demand function / D1*D" << D << " / ;" <<endl ; // declare set D
ofstream Scalars("Scalars.gms") ;  // Scalars required in model constraints //
  Scalars <<"Scalar MaxS0 Maximum storage capacity of dams (GL) / " << MaxS0 << " / ;" <<endl ; // declare maximum dam storage capacity //
  Scalars <<"Scalar MinS0 Minimum storage capacity of dams (GL) / " << MinS0 << " / ;" <<endl ; // declare minimum dam storage capacity //
  Scalars <<"Scalar S0 Initial storage in dams (rolled in to inflows) (GL) / " << S0 << " / ;" <<endl ; // declare intial dam storage //
  Scalars <<"Scalar EvapLoss Evaporative losses from storage / " << EvapLoss << " / ;" <<endl ; // Evaporative losses from storage //
ofstream DF("DF.gms") ;  // Parameter DF(T) Discount factor for each year //
  DF <<"Parameter Df(Yr) Discount factor for each year" <<endl ; // declare the parameter Df //
ofstream GF("GF.gms") ;  // Parameter GF(T) Growth factor for each year //
  GF <<"Parameter Gf(Yr) Growth factor for each year" <<endl ; // declare the parameter Gf //
ofstream YrNd("YrNd.gms") ;  // Set YrNd(Yr,N) Nodes by year //
  YrNd <<"Set YrNd(Yr,N) Nodes by year" <<endl ; // declare the set YrNd //
ofstream LastYrNd("LastYrNd.gms") ;  // Set LastYrNd(Yr,N) Nodes in the last year //
  LastYrNd <<"Set LastYrNd(Yr,N) Nodes in the last year" <<endl ; // declare the set LastYrNd //
ofstream ChildParent("ChildParent.gms") ;  // Set ChildParent(Yr,N,YrP,NP) Ancestor-Successor (parent-child) nodes //
  ChildParent <<"Set ChildParent(Yr,N,YrP,NP) Ancestor-Successor (parent-child) nodes" <<endl ; // declare the set ChildParent //
ofstream ScenMapSas("ScenMapSas.txt") ;  // Output text file for use by SAS //
ofstream ScenMapGAMS("ScenMapGAMS.gms") ;  // Output mapping file for use by GAMS //
  ScenMapGAMS <<"Set ScenMapGAMS(Yr,N,YrP,NP)  Scenario map for each node" <<endl ; // declare the parameter ScenMapGAMS //
ofstream InflowAtNode("InflowAtNode.gms") ;  // parameter InflowAtNode(Yr,N)  Contingent state inflow at each node //
  InflowAtNode <<"parameter InflowAtNode(Yr,N)  Contingent state inflow at each node" <<endl ; // declare the parameter InflowAtNode //
ofstream InflowWghtNd("InflowWghtNd.gms") ;  // parameter InflowWghtNd(Yr,N)  Inflow weight at each node //
  InflowWghtNd <<"parameter InflowWghtNd(Yr,N)  Inflow weight at each node" <<endl ; // declare the parameter InflowWghtNd //
ofstream CumInflowAtNode("CumInflowAtNode.gms") ;  // parameter CumInflowAtNode(Yr,N)  Cumulative contingent state inflow at each node //
  CumInflowAtNode <<"parameter CumInflowAtNode(Yr,N)  Cumulative contingent state inflow at each node" <<endl ; // declare the parameter CumInflowAtNode //
ofstream CondProb("CondProb.gms") ;  // parameter CondProb(Yr,N)  Conditional probability at each node //
  CondProb <<"parameter Condprob(Yr,N)  Conditional probability at each node" <<endl ; // declare the parameter CondProb //
ofstream OpExDam("OpExDam.gms") ;  // Parameter OpExDam(Yr,N) Discount-probability weighted operating cost of dam //
  OpExDam <<"Parameter OpExDam(Yr,N) Discount-probability weighted operating cost of dam" <<endl ; // declare the parameter OpExDam //
ofstream Area("Area.gms") ;  // parameter Area(Yr,N,D,L)  Discount-probability weighted OF coefficient for each linearised demand point //
  Area <<"Parameter Area(Yr,N,D,L) Discount-probability weighted OF coefficient for each linearised demand point" <<endl ; // declare the parameter Area //
ofstream Qty("Qty.gms") ;  // parameter Qty(Yr,N,D,L)  Quantity coefficient for each linearised demand point //
  Qty <<"Parameter Qty(Yr,N,D,L) Quantity coefficient for each aggregated linearised demand point" <<endl ; // declare the parameter Qty //
ofstream AggArea("AggArea.gms") ;  // parameter AggArea(Yr,N,L)  Discount-probability weighted OF coefficient for each linearised demand point //
  AggArea <<"Parameter AggArea(Yr,N,L) Discount-probability weighted OF coefficient for each linearised demand point" <<endl ; // declare the parameter AggArea //
ofstream AggQty("AggQty.gms") ;  // parameter AggQty(Yr,N,L)  Quantity coefficient for each aggregated linearised demand point //
  AggQty <<"Parameter AggQty(Yr,N,L) Quantity coefficient for each aggregated linearised demand point" <<endl ; // declare the parameter AggQty //
ofstream Dprice("Dprice.gms") ;  // parameter Dprice(Yr,N,D,L)  Price for each linearised demand point //
  Dprice <<"Parameter Dprice(Yr,N,D,L) Price for each linearised demand point" <<endl ; // declare the parameter Dprice //
ofstream AggDprice("AggDprice.gms") ;  // parameter AggDprice(Yr,N,L)  Price for each linearised aggregate demand point //
  AggDprice <<"Parameter AggDprice(Yr,N,L) Price for each linearised aggregate demand point" <<endl ; // declare the parameter AggDprice //
ofstream TSA("TSA.gms") ;  // Parameter TermStorArea(Yr,N,M) Discount-probability weighted NSW from terminal storage in dams //
  TSA <<"Parameter TermStorArea(Yr,N,M) Discount-probability weighted NSW from terminal storage in dams" <<endl ; // declare the parameter TSA //
ofstream TSQ("TSQ.gms") ;  // Parameter QtySt(M) Quantity coefficient for each level of terminal storage in dams //
  TSQ <<"Parameter QtySt(M) Quantity coefficient for each level of terminal storage in dams /" <<endl ; // declare the parameter TSQ //

/* Desal streams */
ofstream DesalProdnYrNd("DesalProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  DesalProdnYrNd <<"Set DesalProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream DesalCapLastYrNd("DesalCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  DesalCapLastYrNd <<"Set DesalCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream DesalCapInv("DesalCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  DesalCapInv <<"Set DesalCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream DesalCapMap("DesalCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  DesalCapMap<<"Set DesalCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream DesalCapMaxMap("DesalCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  DesalCapMaxMap <<"set DesalCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  DesalIcap maximum desal capacity (GL) / " << DesalIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  DesalUnitSize Water manufacturing capacity of each plant (GL per year) / " << DesalUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExDesal("OpExDesal.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExDesal <<"Parameter OpExDesal(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExDesal("CapExDesal.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExDesal <<"Parameter CapExDesal(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream DesalPlantCap("DesalPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream DesalScenMapSas("DesalScenMapSas.txt") ;  // Output text file for use by SAS //
/* End desal streams */

/* Aquif streams */
ofstream AquifProdnYrNd("AquifProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  AquifProdnYrNd <<"Set AquifProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream AquifCapLastYrNd("AquifCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  AquifCapLastYrNd <<"Set AquifCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream AquifCapInv("AquifCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  AquifCapInv <<"Set AquifCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream AquifCapMap("AquifCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  AquifCapMap<<"Set AquifCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream AquifCapMaxMap("AquifCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  AquifCapMaxMap <<"set AquifCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  AquifIcap maximum Aquif capacity (GL) / " << AquifIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  AquifUnitSize Water manufacturing capacity of each plant (GL per year) / " << AquifUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
  Scalars <<"Scalar  AquifAdStCap Additional storage capacity from each plant (GL) / " << AquifAdStCap << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExAquif("OpExAquif.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExAquif <<"Parameter OpExAquif(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExAquif("CapExAquif.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExAquif <<"Parameter CapExAquif(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream AquifPlantCap("AquifPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream AquifScenMapSas("AquifScenMapSas.txt") ;  // Output text file for use by SAS //
ofstream AquifSupCap("AquifSupCap.gms") ;  // parameter AquifSupCap(Yr,N)  Aquifer supply capacity at each node //
  AquifSupCap <<"parameter AquifSupCap(Yr,N)  Aquifer supply capacity at each node" <<endl ; // declare the parameter AquifSupCap //
/* End Aquif streams */

/* Recyc streams */
ofstream RecycProdnYrNd("RecycProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  RecycProdnYrNd <<"Set RecycProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream RecycCapLastYrNd("RecycCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  RecycCapLastYrNd <<"Set RecycCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream RecycCapInv("RecycCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  RecycCapInv <<"Set RecycCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream RecycCapMap("RecycCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  RecycCapMap<<"Set RecycCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream RecycCapMaxMap("RecycCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  RecycCapMaxMap <<"set RecycCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  RecycIcap maximum Recyc capacity (GL) / " << RecycIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  RecycUnitSize Water manufacturing capacity of each plant (GL per year) / " << RecycUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExRecyc("OpExRecyc.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExRecyc <<"Parameter OpExRecyc(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExRecyc("CapExRecyc.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExRecyc <<"Parameter CapExRecyc(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream RecycPlantCap("RecycPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream RecycScenMapSas("RecycScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Recyc streams */

/* Tanks streams */
ofstream TanksProdnYrNd("TanksProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  TanksProdnYrNd <<"Set TanksProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream TanksCapLastYrNd("TanksCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  TanksCapLastYrNd <<"Set TanksCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream TanksCapInv("TanksCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  TanksCapInv <<"Set TanksCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream TanksCapMap("TanksCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  TanksCapMap<<"Set TanksCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream TanksCapMaxMap("TanksCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  TanksCapMaxMap <<"set TanksCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  TanksIcap maximum Tanks capacity (GL) / " << TanksIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  TanksUnitSize Water manufacturing capacity of each plant (GL per year) / " << TanksUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExTanks("OpExTanks.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExTanks <<"Parameter OpExTanks(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExTanks("CapExTanks.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExTanks <<"Parameter CapExTanks(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream TanksPlantCap("TanksPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream TanksScenMapSas("TanksScenMapSas.txt") ;  // Output text file for use by SAS //
ofstream TanksSupCap("TanksSupCap.gms") ;  // parameter TanksSupCap(Yr,N)  Tanks supply capacity at each node //
  TanksSupCap <<"parameter TanksSupCap(Yr,N)  Tank supply capacity at each node" <<endl ; // declare the parameter TanksSupCap //
ofstream TradePrNdOut("TradePrNdOut.gms") ;  // parameter TradePrNdOut(Yr,N)  Trade price at each node //
  TradePrNdOut <<"parameter TradePrNdOut(Yr,N)  Trade price at each node" <<endl ; // declare the parameter TradePrNdOut //
/* End Tanks streams */

/* Trade streams */
ofstream TradeProdnYrNd("TradeProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  TradeProdnYrNd <<"Set TradeProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream TradeCapLastYrNd("TradeCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  TradeCapLastYrNd <<"Set TradeCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream TradeCapInv("TradeCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  TradeCapInv <<"Set TradeCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream TradeCapMap("TradeCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  TradeCapMap<<"Set TradeCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream TradeCapMaxMap("TradeCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  TradeCapMaxMap <<"set TradeCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  TradeIcap maximum Trade capacity (GL) / " << TradeIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  TradeUnitSize Water manufacturing capacity of each plant (GL per year) / " << TradeUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExTrade("OpExTrade.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExTrade <<"Parameter OpExTrade(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExTrade("CapExTrade.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExTrade <<"Parameter CapExTrade(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream TradePlantCap("TradePlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream TradeScenMapSas("TradeScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Trade streams */

//
// compute the required information for each node in the decision tree
//
//
// calculate the basic or summary information for each year of the decision tree
//
for (T = 1; T <= NT; T++) {     /* loop over each year */ 
  nat[T] = long(powl(NS,T)) ;  /* calculate the number of nodes in each specific year (scenarios for each year) */
  cumnat[T] = (long(powl(NS,T+1))-long(powl(NS,1)))/(NS-1) ;  /* calculate the cumulative number of nodes for each year */ 
  NumScenYr[T] = long(powl(NS,NT-T)) ;  /* calculate the number of forward scenarios for a node in each year  */ 
  CumNumScenYr[T] = (long(powl(NS,NT+1-T))-long(powl(NS,1)))/(NS-1) ; /* Cumulative number of forward nodes for a node in each year */
  gf[T] = pow(1.0+growth,double(T)-1.0) ;
  Df[T] = pow(1.0+discount,1.0-double(T)) ;
  //
  // Write to file DF
  //
  if (T == 1) {
    DF <<"  / Yr" << T << " = " << Df[T] << "," << endl ;
	GF <<"  / Yr" << T << " = " << gf[T] << "," << endl ;
  }
  else if (T == NT) {
    DF <<"    Yr" << T << " = " << Df[T] << " / ;" << endl ;
	GF <<"    Yr" << T << " = " << gf[T] << " / ;" << endl ;
  }
  else {
    DF <<"    Yr" << T << " = " << Df[T] << "," << endl ;
	GF <<"    Yr" << T << " = " << gf[T] << "," << endl ;
  } ;
  if (T <= NT - DesalInvLag) {  
    TrdesalInvC[T] =
	   (DesalInvC/(1.0-1.0/pow(1.0+discount,double(desallife)))+DesalMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(DesalInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(DesalInvLag)))) ;
  } ;
  if (T <= NT - AquifInvLag) {  
    TraquifInvC[T] =
	   (AquifInvC/(1.0-1.0/pow(1.0+discount,double(aquiflife)))+AquifMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(AquifInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(AquifInvLag)))) ;
  } ;
  if (T <= NT - RecycInvLag) {  
    TrrecycInvC[T] =
	   (RecycInvC/(1.0-1.0/pow(1.0+discount,double(recyclife)))+RecycMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(RecycInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(RecycInvLag)))) ;
  } ;
  if (T <= NT - TanksInvLag) {  
    TrtanksInvC[T] =
	   (TanksInvC/(1.0-1.0/pow(1.0+discount,double(tankslife)))+TanksMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(TanksInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(TanksInvLag)))) ;
  } ;
  if (T <= NT - TradeInvLag) {  
    TrtradeInvC[T] =
	   (TradeInvC/(1.0-1.0/pow(1.0+discount,double(tradelife)))+TradeMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(TradeInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(TradeInvLag)))) ;
  } ;
  x = 0.0 ;
  y = 0.0 ;
  for (I=1; I<=D; I++) {
    bglin[T][I] = blin[I]/gf[T] ;
    x = x - alin[I]/bglin[T][I] ;
    y = y + 1.0/bglin[T][I] ;
  } ;
  Alpha[T] = -(x)/y ;
  Beta[T] = 1.0/y ;
  CreateGamsCode << "Year = " << T << ", Alpha = " << Alpha[T] << ", Beta = " << Beta[T] << endl ;
} ;
//
// calculate the QytSt coefficients for the terminal condition
//
for (K=1; K<=M; K++) {
  QtySt[K] = MaxS0 - (double(K)-1)*(MaxS0 - MinS0)/(double(M)-1) ;
  if (K < M) {
	TSQ <<"    M" << K << " = " << QtySt[K] << "," << endl ;
  } 
  else {
    TSQ <<"    M" << K << " = " << QtySt[K] << " / ;" << endl ;
  } ;
};

//
// for the nodes in year 1, assign the inflows and probabilities
//
for (I = 1; I <= NS; I++) {
  Cr[I] = inflow[I]*EVinflow + S0 ;
  InfWght[I] = inflow[I] ;
  TradePrNd[I] = TradePr[I] ;
  AquifSC[I] = inflow[I] * AquifUnitSize ;
  TanksSC[I] = ((inflow[I] + 1)/2) * TanksUnitSize ;
  CumR[I] = inflow[I]*EVinflow ;
  Cp[I] = prob[I] ;
  P[I] = prob[I] ;
  VarCostDam[I] = Df[1]*Cp[I]*(utcdam+vcdam) ;
} ;
//
// Calculate the node information
//
count = 0 ; /* initialise the node count to zero */ 
for (T = 1; T <= NT; T++) {     /* loop over each year */
  // cout <<"Doing year = " << T << endl ;
  for(I = 1; I <= nat[T]; I++) {  /* loop over the nodes in each year */
    count = count + 1 ;  /* count the nodes as we loop over years and number of nodes in each */
    Nodes[count] = count ;  /* assign a node number to each node */
    NodeTime[count] = T ;  /* assign a year to each node */ 
    NodeAT[count] = I ;  /* assign a number to each node representing its number (or scenario) for the specific year in which it occurs */
	
	cout << "Estimated time remaining: " << 1 + int( (1 - float(count)/float(NNodes))/(float(count)/float(NNodes))*(clock()*CLK_TCK-StartTime*CLK_TCK)/1000000 ) << " seconds. (Year " << T << ", Node " << count << ", of total nodes " << NNodes << ")" << endl ;
	
	x = double(NodeAT[count]) ;
    if (fmod(x, double(NS)) == 0) {
      StateAtNode[count] = 3 ;
    }
    else {
      StateAtNode[count] = long (fmod(x, double(NS))) ;
    } ;
    //
    //  write records to file YrNd
    //
    if (count == 1) {
      YrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count > 1 && count < NNodes) {
      YrNd <<"    Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count == NNodes) {
      YrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
    } ;

	//
	// calculate and write the long-run marginal cost pricing block nodes TIM
	//

	if(NodeAT[count] == 1) {
		if( ((T-1) % block_length) == 0 ) {
			start_block ++ ;
			total_block ++ ;
			block = total_block ;
			start_block = total_block ;
			// cout << start_block << " start " << total_block << " total " << total_block << " using " << endl ;
		} ;
		if( ((T-1) % block_length) != 0 ) {
			block = start_block ;
			// cout << start_block << " start " << total_block << " total " << start_block << " using " << endl ;
		} ;
		bcount = 0 ;
	} ;
	if(bcount == long long (powf(NS , (((T - 1) % block_length) + 1))) ) {
		if( ((T-1) % block_length) == 0 ) {
			total_block ++ ;
		} ;
		block ++ ;
		bcount = 0 ;
	};
	bcount ++ ;	
//    cout << start_block << " start " << total_block << " total " << endl ;


    if (count == 1) {
      NdPrBlk <<"  / Yr" << T << ".N" << count << ".P" << block << "," << endl ;
    } 
    else if (count > 1 && count < NNodes) {
      NdPrBlk <<"    Yr" << T << ".N" << count << ".P" << block << "," << endl ;
    } 
    else if (count == NNodes) {
      NdPrBlk <<"    Yr" << T << ".N" << count << ".P" << block << " / ;" << endl ;
	  Sets <<"Set PrBlk Number of pricing blocks / P1*P" << block << " / ;" <<endl ; // declare set PrBlk
    } ;


    //
    //  write records to file CapLastYrNd
    //
    if (T == NT - DesalInvLag) {
      if (count == cumnat[T-1] + 1) {
        DesalCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        DesalCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        DesalCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - AquifInvLag) {
      if (count == cumnat[T-1] + 1) {
        AquifCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        AquifCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        AquifCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - RecycInvLag) {
      if (count == cumnat[T-1] + 1) {
        RecycCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        RecycCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        RecycCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - TanksInvLag) {
      if (count == cumnat[T-1] + 1) {
        TanksCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        TanksCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        TanksCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - TradeInvLag) {
      if (count == cumnat[T-1] + 1) {
        TradeCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        TradeCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        TradeCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    //
    //  write records to files InflowAtNode, CondProb, OpEx, and OpExDam for nodes in the first year
    //
    if (T == 1 && count == 1) {
      InflowAtNode <<"  / Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
	  InflowWghtNd <<"  / Yr" << T << ".N" << count << " = "<< InfWght[count] << "," << endl ;
	  TradePrNdOut <<"  / Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ;
	  AquifSupCap <<"  / Yr" << T << ".N" << count << " = "<< AquifSC[count] << "," << endl ;
	  TanksSupCap <<"  / Yr" << T << ".N" << count << " = "<< TanksSC[count] << "," << endl ;
      CumInflowAtNode <<"  / Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
      CondProb <<"  / Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      OpExDam << "  / Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
    } 
    else if (T == 1 && count > 1 ) {
      InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
	  InflowWghtNd <<"    Yr" << T << ".N" << count << " = "<< InfWght[count] << "," << endl ;      
	  TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ;      
	  AquifSupCap <<"    Yr" << T << ".N" << count << " = "<< AquifSC[count] << "," << endl ;      
	  TanksSupCap <<"    Yr" << T << ".N" << count << " = "<< TanksSC[count] << "," << endl ;      
	  CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
      CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
    } ;
    if (T > 1) {          /* do the following calculations for nodes not in the first year (ie strictly child nodes) */
      x = double(double(count)/double(NS)) ;
      ParNodeNumber[count] = long ((ceil(x)) - 1) ; /* calculate the parent node number of the current child node */  
      ParNodeTime[count] = T-1 ;    /* assign the year of the parent node */
      ParNodeNat[count] = NodeAT[ParNodeNumber[count]] ; /* assign the parent node number for its year */
      ChildNodeNumber[StateAtNode[count]][ParNodeNumber[count]] = count ; /* assign the child node number to the parent node */
      ChildNodeTime[StateAtNode[count]][ParNodeNumber[count]] = T ; /* assign the child year to the parent node */
      ChildNodeNat[StateAtNode[count]][ParNodeNumber[count]] = I ; /* assign the child node number in its year to the parent node */
      Cr[count] = inflow[StateAtNode[count]]*EVinflow ;  /* assign the contingent inflow to the child node */
	  InfWght[count] = inflow[StateAtNode[count]] ;  /* assign the contingent inflow weight to the child node */
	  TradePrNd[count] = TradePr[StateAtNode[count]] ;
	  AquifSC[count] = inflow[StateAtNode[count]] * AquifUnitSize ;  
	  TanksSC[count] = ((inflow[StateAtNode[count]] + 1)/2) * TanksUnitSize ;  
      CumR[count] = CumR[ParNodeNumber[count]] + inflow[StateAtNode[count]]*EVinflow ;  /* calculate and assign assign the cumulative contingent inflow to the child node */
      Cp[count] = Cp[ParNodeNumber[count]] * prob[StateAtNode[count]] ;  /* calculate and assign the conditional probability of the child node */ 
      P[count] = prob[StateAtNode[count]] ;  /* assign the contingent state probability to the child node */
      VarCostDam[count] = Df[T]*Cp[count]*(utcdam+vcdam) ;
      //
      // Write records to file OpExDam
      //
      if (count == NNodes) {
        OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << " / ;" << endl ;
      } 
      else {
        OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
      } ;

/*	  
	  if (T == NT) {
        PriceWaterStored[count] = uvts*Df[T]*Cp[count]/(1+discount) ;
        //
        // Write records to file TSP
        //
        if (count == cumnat[NT-1] + 1) {
          TSP <<"  / Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << "," << endl ;
        } 
        else if (count > cumnat[NT-1] + 1 && count < NNodes) {
          TSP <<"    Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << "," << endl ;
        } 
        else if (count == NNodes) {
          TSP <<"    Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << " / ;" << endl ;
        } ;
      } ;
*/

	  if (T == NT) {
        for (K=1; K<=M; K++) {        
		  TermStorArea[count][K] = Df[T]*gf[T]*Cp[count]/(1+discount)*Aterm/(bterm+1)*(pow(QtySt[K],bterm+1)-pow(MinS0,bterm+1)) ;
		  //TermStorArea[count][K] = Df[T]*gf[T]*Cp[count]/(1+discount)*(0.5*Aterm*QtySt[K]*QtySt[K] + bterm*QtySt[K] - 0.5*Aterm*MinS0*MinS0 - bterm*MinS0) ;
          //
          // Write records to file TSA
          //
          if ((count == cumnat[NT-1] + 1) && K==1) {
	        TSA <<"  / Yr" << T << ".N" << count << ".M" << K << " = " << TermStorArea[count][K] << "," << endl ;
          } 
          else if (count == NNodes && K==M) {
            TSA <<"    Yr" << T << ".N" << count << ".M" << K << " = " << TermStorArea[count][K] << " / ;" << endl ;
          } 
		  else {
	        TSA <<"    Yr" << T << ".N" << count << ".M" << K << " = " << TermStorArea[count][K] << "," << endl ;
          } ;
        } ;
      };




      //
      //  write records to file ChildParent
      //
	  if (count == cumnat[1]+1) {
        ChildParent <<"  / Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        ChildParent <<"    Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << " / ;"<< endl ;
      }
      else if (count > cumnat[1]+1 && count < NNodes) {
        ChildParent <<"    Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << "," << endl ;
      }  ;
      //
      //  write records to files InflowAtNode and CondProb for nodes not in the first year
      //
      if (count < NNodes) {
        InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
		InflowWghtNd <<"    Yr" << T << ".N" << count << " = "<< InfWght[count] << "," << endl ; 
		TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ; 
		AquifSupCap <<"    Yr" << T << ".N" << count << " = "<< AquifSC[count] << "," << endl ; 
		TanksSupCap <<"    Yr" << T << ".N" << count << " = "<< TanksSC[count] << "," << endl ; 
        CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
        CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      } 
      else if (count == NNodes ) {
        InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << " / ;" << endl ;
		InflowWghtNd <<"    Yr" << T << ".N" << count << " = "<< InfWght[count] << " / ;" << endl ; 
		TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << " / ;" << endl ; 
		AquifSupCap <<"    Yr" << T << ".N" << count << " = "<< AquifSC[count] << " / ;" << endl ; 
		TanksSupCap <<"    Yr" << T << ".N" << count << " = "<< TanksSC[count] << " / ;" << endl ; 
        CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << " / ;" << endl ;
        CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << " / ;" << endl ;
      } ;
    } ;
    //
    //  write records to file CapInv and CapEx
    //
    if (T <= NT - DesalInvLag) {
	  CapCostDesal[count] = TrdesalInvC[T]*Cp[count] ;
      if (count == 1) {
        DesalCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExDesal << "  / Yr" << T << ".N" << count << " = " << CapCostDesal[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-DesalInvLag]) {
        DesalCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExDesal << "    Yr" << T << ".N" << count << " = " << CapCostDesal[count] << " / ;" << endl ;
      } 
      else {
        DesalCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExDesal << "    Yr" << T << ".N" << count << " = " << CapCostDesal[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - AquifInvLag) {
	  CapCostAquif[count] = TraquifInvC[T]*Cp[count] ;
      if (count == 1) {
        AquifCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExAquif << "  / Yr" << T << ".N" << count << " = " << CapCostAquif[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-AquifInvLag]) {
        AquifCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExAquif << "    Yr" << T << ".N" << count << " = " << CapCostAquif[count] << " / ;" << endl ;
      } 
      else {
        AquifCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExAquif << "    Yr" << T << ".N" << count << " = " << CapCostAquif[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - RecycInvLag) {
	  CapCostRecyc[count] = TrrecycInvC[T]*Cp[count] ;
      if (count == 1) {
        RecycCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExRecyc << "  / Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-RecycInvLag]) {
        RecycCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExRecyc << "    Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << " / ;" << endl ;
      } 
      else {
        RecycCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExRecyc << "    Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - TanksInvLag) {
	  CapCostTanks[count] = TrtanksInvC[T]*Cp[count] ;
      if (count == 1) {
        TanksCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExTanks << "  / Yr" << T << ".N" << count << " = " << CapCostTanks[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-TanksInvLag]) {
        TanksCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExTanks << "    Yr" << T << ".N" << count << " = " << CapCostTanks[count] << " / ;" << endl ;
      } 
      else {
        TanksCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExTanks << "    Yr" << T << ".N" << count << " = " << CapCostTanks[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - TradeInvLag) {
	  CapCostTrade[count] = TrtradeInvC[T]*Cp[count] ;
      if (count == 1) {
        TradeCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExTrade << "  / Yr" << T << ".N" << count << " = " << CapCostTrade[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-TradeInvLag]) {
        TradeCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExTrade << "    Yr" << T << ".N" << count << " = " << CapCostTrade[count] << " / ;" << endl ;
      } 
      else {
        TradeCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExTrade << "    Yr" << T << ".N" << count << " = " << CapCostTrade[count] << "," << endl ;
      } 
    } ;


    for (K=1; K<=L; K++) {
      AggQtyQd[count][K] = (PriceLin[K] - Alpha[T])/Beta[T] ;
      AggAreaQd[count][K] =
        (Alpha[T]*AggQtyQd[count][K] + 0.5*Beta[T]*AggQtyQd[count][K]*AggQtyQd[count][K])*Df[T]*Cp[count] ;
      //
      // Write records to file AggArea and AggQty
      //
      if (count == 1 && T == 1 && K == 1) {
        AggDprice <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << "," << endl ;
        AggArea <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << "," << endl ;
        AggQty <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << "," << endl ;
      } 
      else if (count == NNodes && T == NT && K == L) {
        AggDprice <<"    Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << " / ;" << endl ;
        AggArea <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << " / ;" << endl ;
        AggQty <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << " / ;" << endl ;
      } 
      else{
        AggDprice <<"    Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << "," << endl ;
        AggArea <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << "," << endl ;
        AggQty <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << "," << endl ;
      } ;
    } ;
    for (J=1; J<=D; J++) {
      for (K=1; K<=L; K++) {
        QtyQd[count][J][K] = (PriceLin[K] - alin[J])/bglin[T][J] ;
        AreaQd[count][J][K] =
          (alin[J]*QtyQd[count][J][K] + 0.5*bglin[T][J]*QtyQd[count][J][K]*QtyQd[count][J][K])*Df[T]*Cp[count] ;
        //
        // Write records to file Area and Qty
        //
        if (count == 1 && J ==1 && K == 1) {
          Dprice <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << "," << endl ;
          Area <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << "," << endl ;
          Qty <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << "," << endl ;
        } 
        else if (count == NNodes && J == D && K == L) {
          Dprice <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << " / ;" << endl ;
          Area <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << " / ;" << endl ;
          Qty <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << " / ;" << endl ;
        } 
        else{
          Dprice <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << "," << endl ;
          Area <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << "," << endl ;
          Qty <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << "," << endl ;
        } ;
      } ;
    } ;
    //
    //  write records to file CapMaxMap
    //
    if (T == NT-DesalInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          DesalCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          DesalCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          DesalCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-AquifInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          AquifCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          AquifCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          AquifCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-RecycInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          RecycCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          RecycCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          RecycCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-TanksInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          TanksCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          TanksCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TanksCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-TradeInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          TradeCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          TradeCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TradeCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;

    //
    //  write records to file LastYrNd
    //
    if (count == cumnat[NT-1] + 1) {
      LastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count > cumnat[NT-1] + 1 && count < NNodes) {
      LastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count == NNodes) {
      LastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
    } ;
    //
    //  write records to file DesalScenMapSas and ScenMapSas
    //
    if (count > cumnat[NT-1]) {
      // DesalScenMapSas
      for (TT = 1; TT <= T-DesalInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + DesalInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            DesalScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // AquifScenMapSas
      for (TT = 1; TT <= T-AquifInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + AquifInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            AquifScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // RecycScenMapSas
      for (TT = 1; TT <= T-RecycInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + RecycInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            RecycScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // TanksScenMapSas
      for (TT = 1; TT <= T-TanksInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + TanksInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            TanksScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // TradeScenMapSas
      for (TT = 1; TT <= T-TradeInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + TradeInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            TradeScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;

	  // ScenMapSas
      for (TT = 1; TT <= NT; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
        ScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << endl ;

		if (J == 1 && count == cumnat[NT-1] + 1 ) {
          ScenMapGAMS <<"  / Yr" << TT << ".N" << J << ".Yr" <<  T << ".N" << count << "," << endl ;
        } 
        else if (J == NNodes) {
          ScenMapGAMS <<"    Yr" << TT << ".N" << J << ".Yr" <<  T << ".N" << count << " / ;"<< endl ;
        }
        else {
          ScenMapGAMS <<"    Yr" << TT << ".N" << J << ".Yr" <<  T << ".N" << count << "," << endl ;
        }  ;

      } ;
    } ;
    //
    // write records to files ProdnYrNd, OpEx and CapMap
    //
	if (T > DesalInvLag) {
      VarCostDesal[count] = Df[T]*Cp[count]*(utcdam+vcdesal) ;
      CapCostDesal[count] = Cp[count]*TrdesalInvC[T] ;
      if (count == cumnat[DesalInvLag] + 1) {
        DesalProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal << "  / Yr" << T << ".N" << count << " = " << VarCostDesal[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        DesalProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExDesal << "    Yr" << T << ".N" << count << " = " << VarCostDesal[count] << " / ;" << endl ;
      } 
      else {
        DesalProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal << "    Yr" << T << ".N" << count << " = " << VarCostDesal[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-DesalInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == DesalInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          DesalCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - DesalInvLag) {
          DesalCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          DesalCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > AquifInvLag) {
      VarCostAquif[count] = Df[T]*Cp[count]*(utcdam+vcaquif) ;
      CapCostAquif[count] = Cp[count]*TraquifInvC[T] ;
      if (count == cumnat[AquifInvLag] + 1) {
        AquifProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif << "  / Yr" << T << ".N" << count << " = " << VarCostAquif[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        AquifProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExAquif << "    Yr" << T << ".N" << count << " = " << VarCostAquif[count] << " / ;" << endl ;
      } 
      else {
        AquifProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif << "    Yr" << T << ".N" << count << " = " << VarCostAquif[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-AquifInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == AquifInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          AquifCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - AquifInvLag) {
          AquifCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          AquifCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > RecycInvLag) {
      VarCostRecyc[count] = Df[T]*Cp[count]*(utcdam+vcrecyc) ;
      CapCostRecyc[count] = Cp[count]*TrrecycInvC[T] ;
      if (count == cumnat[RecycInvLag] + 1) {
        RecycProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExRecyc << "  / Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        RecycProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExRecyc << "    Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << " / ;" << endl ;
      } 
      else {
        RecycProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExRecyc << "    Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-RecycInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == RecycInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          RecycCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - RecycInvLag) {
          RecycCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          RecycCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > TanksInvLag) {
      VarCostTanks[count] = Df[T]*Cp[count]*(utcdam+vctanks) ;
      CapCostTanks[count] = Cp[count]*TrtanksInvC[T] ;
      if (count == cumnat[TanksInvLag] + 1) {
        TanksProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExTanks << "  / Yr" << T << ".N" << count << " = " << VarCostTanks[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        TanksProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExTanks << "    Yr" << T << ".N" << count << " = " << VarCostTanks[count] << " / ;" << endl ;
      } 
      else {
        TanksProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExTanks << "    Yr" << T << ".N" << count << " = " << VarCostTanks[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-TanksInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == TanksInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          TanksCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - TanksInvLag) {
          TanksCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TanksCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > TradeInvLag) {
      VarCostTrade[count] = Df[T]*Cp[count]*(utcdam+TradePrNd[count]) ;
      CapCostTrade[count] = Cp[count]*TrtradeInvC[T] ;
      if (count == cumnat[TradeInvLag] + 1) {
        TradeProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExTrade << "  / Yr" << T << ".N" << count << " = " << VarCostTrade[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        TradeProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExTrade << "    Yr" << T << ".N" << count << " = " << VarCostTrade[count] << " / ;" << endl ;
      } 
      else {
        TradeProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExTrade << "    Yr" << T << ".N" << count << " = " << VarCostTrade[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-TradeInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == TradeInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          TradeCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - TradeInvLag) {
          TradeCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TradeCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;

  } ; /* End of the main FOR loop over I (Nodes at time T) */
} ; /* End of the main FOR loop over time [T] */
cout <<"All done!" << endl ;
EndTime = clock() ;
CreateGamsCode << "Finish time " << EndTime/CLK_TCK << endl ;
CreateGamsCode << "Elapsed time " << (EndTime-StartTime)/CLK_TCK << endl ;
}  /* End of the main program */

