$Title Quadratic Urban Water Small
$maxcol 125
$onsymlist
$onsymxref
$oninline
$ontext
*** Linearised Urban Water Limited ***
Outlined below is a multistage stochastic spatial and temporal programming model of an urban
water system. The model maximises Net Social Welfare (Marshallian Consumer plus producer
surplus). This is a reduced version of the full model. It only includes desalination as an
investment option.
$offtext
option decimals = 2 ;
option profile = 2 ;

$offlisting

$include "Sets.gms"

$include "YrNd.gms"

$include "LastYrNd.gms"

$include "ChildParent.gms"

$include "InflowAtNode.gms"

$include "InflowWghtNd.gms"

$include "CumInflowAtNode.gms"

$include "CondProb.gms"

$include "Scalars.gms"

$include "DF.gms"

$include "GF.gms"

$include "AggArea.gms"

$include "Area.gms"

$include "AggQty.gms"

$include "Qty.gms"

$include "OpExDam.gms"

$include "TSQ.gms"

$include "TSA.gms"

$include "DPrice.gms"

$include "NdPrBlk.gms"

$include "DesalCapLastYrNd.gms"
$include "DesalCapMap.gms"
$include "DesalCapInv.gms"
$include "DesalProdnYrNd.gms"
$include "DesalCapMaxMap.gms"
$include "OpExDesal.gms"
$include "CapExDesal.gms"

$include "AquifCapLastYrNd.gms"
$include "AquifCapMap.gms"
$include "AquifCapInv.gms"
$include "AquifProdnYrNd.gms"
$include "AquifCapMaxMap.gms"
$include "OpExAquif.gms"
$include "CapExAquif.gms"
$include "AquifSupCap.gms"

$include "RecycCapLastYrNd.gms"
$include "RecycCapMap.gms"
$include "RecycCapInv.gms"
$include "RecycProdnYrNd.gms"
$include "RecycCapMaxMap.gms"
$include "OpExRecyc.gms"
$include "CapExRecyc.gms"

$include "TanksCapLastYrNd.gms"
$include "TanksCapMap.gms"
$include "TanksCapInv.gms"
$include "TanksProdnYrNd.gms"
$include "TanksCapMaxMap.gms"
$include "OpExTanks.gms"
$include "CapExTanks.gms"
$include "TanksSupCap.gms"

$include "TradeCapLastYrNd.gms"
$include "TradeCapMap.gms"
$include "TradeCapInv.gms"
$include "TradeProdnYrNd.gms"
$include "TradeCapMaxMap.gms"
$include "OpExTrade.gms"
$include "CapExTrade.gms"

$onlisting
