// Cpp2GamsCode.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <cmath>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <ctime>
#define MaxNodes 88573
#define MaxYears 11
#define MaxStates 4
#define MaxDemand 4
#define MaxLin 40
#define MaxLinTS 20
using namespace std ;
int main() {  /* start of the main program */
//
// declare scalars and arrays set up for a maximum of 10 years
//
static long I ; /* scalar for iterating through sets (arrays) using FOR/NEXT */
static long II ; /* second I scalar for iterating through sets (arrays) using FOR/NEXT */
static long III ; /* third I scalar for iterating through sets (arrays) using FOR/NEXT */
static long J ; /* scalar for iterating through sets (arrays) using FOR/NEXT */
static long K ; /* scalar for iterating through sets (arrays) using FOR/NEXT */ 
static long L ; /* the number of linearisations of each demand function */
static long M ; /* the number of linearisations of each terminal storage demand function */
static long NS ; /* number (or card of the set) of contingent (probability) states */
static long S ; /* scalar (ord) used to loop over the set of contingent probability states */
static long NT ; /* number (or card of the set) of time periods (or stages) */ 
static long T ; /* scalar (ord) used to loop over the set of time periods */
static long TT ; /* second scalar (ord) used to loop over the set of time periods */
static long TTT ; /* third scalar (ord) used to loop over the set of time periods */
static long NScen ; /* Total number (card) of scenarios (leaves) in the decision tree */
static long NumScenYr[MaxYears] ; /* Number of forward scenarios for a node in each year */
static long CumNumScenYr[MaxYears] ; /* Cumulative number of forward scenarios for a node in each year */
static long NNodes ; /* Total number (card) of nodes in the decision tree, including root node */
static long count ; /* counter used to add up the total number of nodes */
static long D ; /* number of classes of demand for water */
static long nat[MaxYears] ; /* number of nodes at each time or stage */ 
static long cumnat[MaxYears] ; /* cumulative number of nodes at each time or stage */
static long StateAtNode[MaxNodes] ; /* contingent state for each node */
static long Nodes[MaxNodes] ; /* set (or ord) of nodes */ 
static long NodeTime[MaxNodes] ; /* time period in which node occurs */ 
static long NodeAT[MaxNodes] ; /* set (or ord) of nodes for each time period (stage) */ 
static long ChildNodeNumber[MaxStates][MaxNodes] ; /* Child node number */ 
static long ChildNodeTime[MaxStates][MaxNodes] ; /* Child node time */ 
static long ChildNodeNat[MaxStates][MaxNodes] ; /* Chile node number for its time period */ 
static long ParNodeNumber[MaxNodes] ; /* Parent node number */ 
static long ParNodeTime[MaxNodes] ; /* Parent node time */ 
static long ParNodeNat[MaxNodes] ; /* Parent node node number for its time period */
static long desal2lag ; /* Lag from t=1 to time period when desal2 can start production */
static long MAvg ; /*Block size for calculating the moving average of aquifer drawdown */
static long YearIndex ; /* Number of years in each time period */
static double MultiYear ; /* Objective function coefficient for each time period */
static double discount ; /* discount rate */
static double growth ; /* annual growth rate in demand */ 
static double EVinflow ; /* Expected value (mean) inflows per year (GL) */
static double utcdam ; /* Unit cost of delivering water through the distribution network ($M per GL) */
static double vcdam ; /* Unit cost of supplying water from dams ($M per GL) */
static double vcdesal1 ; /* Unit cost of supplying water from existing desal (Kwinana) ($M per GL) */
static double vcdesal2 ; /* Unit cost of supplying water from existing desal (Southern) ($M per GL) */
static double vcaquif0 ; /* Unit cost of supplying water from existing aquifers ($M per GL) */
static double MaxS0 ; /* Initial storage capacity of dams (GL) */
static double MinS0 ; /* Initial minimum storage storage capacity of dams (GL) */
static double S0 ; /* Initial storage of water in dams (GL) */
static double EvapLoss ; /* Evaporation from dams */
static double uvts ; /* unit value dam storage in the terminal year */
static double x ; /* parameter used to pass real double floating point arguments to math functions */
static double y ; /* parameter used to pass real double floating point arguments to math functions */
static double PriceUp ; /* Maximum price used for linearising the demand functions */
static double PriceLo ; /* Minimum price used for linearising the demand functions */
static double PriceLin[MaxLin] ; /* Price at each linearisation point [Max of 100 linearisation points] */
static double QtyTSUp ; /* Maximum qty used for linearising the terminal storage demand functions */
static double QtyTSLo ; /* Minimum qty used for linearising the terminal storage demand functions */
static double QtyTSLin[MaxLinTS] ; /* Qty at each linearisation point [Max of 20 linearisation points] */
static double Df[MaxYears] ; /* Discount factor for each each */
static double gf[MaxYears] ; /* demand growth factor for each year */
static double ArcE[MaxDemand] ; /* arc elasticity of demand for each state */
static double Pi ; /* lower price bound for arc elasticity */
static double Pf ; /* upper price bound for arc elasticity */
static double Pt ; /* Initial price point to calculate demand curves */
static double Qi[MaxDemand] ; /* lower qty bound for arc elasticity for each state*/
static double Qf[MaxDemand] ; /* upper qty bound for arc elasticity for each state */
static double Qt[MaxDemand] ; /* current qty point to calculate demand curves for each state */
static double Qtot ; /* Initial quantity point (total for all demand types) to calculate demand curves */
static double Usershare[MaxDemand] ; /* Shares of the initial total demand by type of demand */
static double alin[MaxDemand] ; /* Constant (intercept) for the inverse demand curve ($M per GL 348) */ 
static double blin[MaxDemand] ; /* Slope for the inverse demand curve */
static double bglin[MaxYears][MaxDemand] ; /* Slope for the inverse demand curve adjusted for growth over time */
static double Alpha[MaxYears] ; /* Constant (intercept) for the inverse of the aggregated demand curve ($M per GL 348) */ 
static double Beta[MaxYears] ; /* Slope for the inverse of the aggregated demand curve adjusted for growth over time */
static double AreaQd[MaxNodes][MaxDemand][MaxLin] ; /* Discount-probability weighted cumulative area under each linearised demand point */
static double QtyQd[MaxNodes][MaxDemand][MaxLin]  ; /* Quantity demanded for each linearised demand point */
static double AggAreaQd[MaxNodes][MaxLin] ; /* Discount-probability weighted aggregated cumulative area under each linearised demand point */
static double AggQtyQd[MaxNodes][MaxLin]  ; /* Aggregate quantity demanded for each linearised demand point */
static double AreaQdTS[MaxNodes][MaxLinTS] ; /* Discount-probability weighted cumulative area under each linearised demand point */
static double AreaQdTSRest[MaxNodes][MaxLinTS] ; /* Discount-probability weighted cumulative area under each linearised demand point */
static double PriceTS[MaxNodes][MaxLinTS]  ; /* Price for each linearised demand point */
static double aTS ; /* intercept for terminal storage function */
static double bTS ; /* slope for terminal storage function */
static double RestTerm[MaxLinTS] ; /* Cost of restrictions in terminal condition */
static double prob[MaxStates] ; /* Probability for each contingent state */ 
static double inflow[MaxStates] ; /* Inflow (GL/yr) for each contingent state */
static double Cr[MaxNodes] ; /* Conditional stochastic inlow for each node in each stage of the decision tree */
static double CumR[MaxNodes] ; /* Cumulative conditional stochastic inlow for each node in each stage of the decision tree */
static double Cp[MaxNodes] ;  /* Conditional probability for each node in each stage of the decision tree */
static double P[MaxNodes] ; /* Probability for each node in each stage of the decision tree */
static double VarCostDam[MaxNodes] ; /* Discount-probability cost of operating dams */
static double VarCostDesal1[MaxNodes] ; /* Discount-probability cost of operating existing desal (Kwinana) */
static double VarCostDesal2[MaxNodes] ; /* Discount-probability cost of operating existing desal (Southern) */
static double VarCostAquif0[MaxNodes] ; /* Discount-probability cost of operating existing aquifers */
static double PriceWaterStored[MaxNodes] ; /* Discount-probability price of water in storage in the terminal period */
/* Long-run marginal cost related parameters for set generation */
static long start_block /* The initial pricing block appropriate for the first node in a year */ ;
static long total_block /* The running cumulative total of pricing blocks */ ;
static long bcount /* Counter used for totalling blocks */ ;
static long block /* The block appropriate for the current YrNd */ ;
static long block_length /* The period after which long-run marginal cost is recalibrated */ ;
/* Initialisation */
start_block = 0 ;
bcount = 1 ;
block_length = 2 ;
/* streams */
ofstream NdPrBlk("NdPrBlk.gms") ;  // Set NdPrBlk(Yr,N,PrBlk) Mapping nodes to blocks //
  NdPrBlk <<"Set NdPrBlk(Yr,N,PrBlk) mapping between N and price blocks " <<endl ; // declare the mapping NdPrBlk //



//
// Open CreateGamsCode.lst file to write a log of time taken for the task
//
ofstream CreateGamsCode("CreateGamsCode.lst") ;  
  clock_t StartTime, EndTime ;
  StartTime = clock() ;
  CreateGamsCode <<"Start time = " << StartTime/CLK_TCK << endl ;
//
// define the initial dimensions of the scenario and contingent states and relevant data
//
NT = 10 ;
if (NT > MaxYears - 1) {
  cout << NT << " is too many years. The maximum allowed is " << MaxYears-1 << endl ;
  return(0) ;
} ;
NS = 3 ;
if (NS > MaxStates - 1) {
  cout << NS << " is too many states. The maximum allowed is " << MaxStates-1 << endl ;
  return(0) ;
} ;
L = 20 ; /* The number of linearisations of each demand function */
if (L > MaxLin - 1) {
  cout << L << " is too many linear segments. The maximum allowed is " << MaxLin-1 << endl ;
  return(0) ;
} ;
M = 12 ; /* The number of linearisations of the terminal storage demand function */
if (M > MaxLinTS - 1) {
  cout << M << " is too many linear segments. The maximum allowed is " << MaxLinTS-1 << endl ;
  return(0) ;
} ;

YearIndex = 2 ;
MultiYear = 0 ;
for( I=1; I<=YearIndex; I++){
	MultiYear = MultiYear + pow(1.0+discount,1-I) ;
} ;
MAvg = 3 ;

if (YearIndex == 1) { 
prob[1] = 0.240 ; /* contingent state 1 */
prob[2] = 0.557 ;  /* contingent state 2 */
prob[3] = 0.203 ; /* contingent state 3 */
inflow[1] = 0.356656 ; /* contingent state 1 */
inflow[2] = 1.010348 ; /* contingent state 2 */
inflow[3] = 1.732211 ; /* contingent state 3 */
EVinflow = 0.24*54.682 + 0.557*154.905 + 0.203*265.580 ;
}
else if (YearIndex ==2) {
prob[1] = 0.210 ; /* contingent state 1 */
prob[2] = 0.597 ;  /* contingent state 2 */
prob[3] = 0.193 ; /* contingent state 3 */
inflow[1] = 0.524479462 ; /* contingent state 1 */
inflow[2] = 1.003996336 ; /* contingent state 2 */
inflow[3] = 1.505044044 ; /* contingent state 3 */
EVinflow = (0.210*81.117  + 0.597*155.280 + 0.193*232.773) ;
} ;
discount = 0.06 ;
growth = 0.021 ; 
utcdam = 0.12 ;
vcdam = 0.10 ;
vcdesal1 = 0.47 ;
vcdesal2 = 0.86 ;
vcaquif0 = 0.20 ;
desal2lag = 1 ;
MaxS0 = 622.0 ;
MinS0 = 110 ;
S0 = 0.30*MaxS0 ;
EvapLoss = 0.04 ;
uvts = 2.0 ;

ArcE[1] = -0.1 ; 
ArcE[2] = -0.3 ;
ArcE[3] = -0.3 ;
Pi = 0.5 ;
Pf = 5 ;
Pt = 0.88 ;
Qtot = 276 ;
Usershare[1] = 0.7*0.55 ; /* indoor */
Usershare[2] = 0.7*0.45 ; /* outdoor */
Usershare[3] = 0.3 ; /* comm */
//alin[1] = 16.5 ; /* indoor */
//alin[2] = 7.333 ; /* outdoor */
//alin[3] = 7.333 ; /* comm */
//blin[1] = -0.136 ;  /* indoor */
//blin[2] = -0.067 ;  /* outdoor */
//blin[3] = -0.070 ;  /* comm */
D = 3 ;
PriceLo = vcdam + utcdam - 0.01 ;
PriceUp = 999999 ;
aTS = 0.3619 ;
bTS = -0.0004 ;
QtyTSLo = 110 ;
QtyTSUp = 622 ;
for (I=1; I<=D; I++){
  Qt[I] = Usershare[I] * Qtot ;
  Qi[I] =  Qt[I] * (((Pf - Pi)  *(Pf + Pi - ArcE[I] * (Pf - Pi)))
	      /((Pt - Pi) * (Pf + Pi + ArcE[I] * (Pf - Pi)) - (Pt - Pf) * (Pf + Pi - ArcE[I] * (Pf - Pi)))) ;
  Qf[I] = Qi[I] * ((Pf + Pi + ArcE[I] * (Pf - Pi)) / (Pf + Pi - ArcE[I] * (Pf - Pi))) ;
  blin[I] = (Pf - Pi) / (Qf[I] - Qi[I]) ;
  alin[I] = Pi - Qi[I] * blin[I] ;
  
  if (alin[I] < PriceUp){
   PriceUp = alin[I] ;
  } ;
} ;
for (I=1; I<=L; I++) { 
  PriceLin[I] = PriceUp - double(I)*(PriceUp - PriceLo)/double(L) ;
} ;
for (I=1; I<=M; I++) { 
  QtyTSLin[I] = QtyTSUp + ((QtyTSUp - QtyTSLo)/(double(M)-1)) 
	            - double(I)*(QtyTSUp - QtyTSLo)/(double(M)-1) ;
} ;

/* Desal specific investment parameters for calculations */
static long DesalInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
DesalInvLag = 4/YearIndex ; /* Lag on the investment */
static long desallife ; /* life of plant (years) */
desallife = 30/YearIndex ; /* Life of a plant in years */
static double vcdesal ; /* Unit cost of supplying water ($M per GL) */
vcdesal = 0.86 ;
static double DesalInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
DesalInvC =  955 ; /* $m for plant of UnitSize rated capacity */
static double DesalMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
DesalMainC =  5 ; /* $m for plant of UnitSize rated capacity */
static double DesalUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
DesalUnitSize = 50.0 ;
static long DesalIcap ; /* maximum capacity (GL) */
DesalIcap = 50/DesalUnitSize ; /* Maximum total installed capacity across all plants */
static double TrdesalInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostDesal[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostDesal[MaxNodes] ; /* Discount-probability capital cost of building */
/* End desal parameters */

/* Aquifer specific investment parameters for calculations */
static long AquifInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
AquifInvLag = (3+1)/YearIndex ; /* Lag on the investment */
static long aquiflife ; /* life of plant (years) */
aquiflife = 50.0/YearIndex ; /* Life of a plant in years */
static double vcaquif ; /* Unit cost of supplying water ($M per GL) */
vcaquif = 0.20 ;
static double AquifInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
AquifInvC =  225.10 ; /* $m for plant of UnitSize rated capacity */
static double AquifMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
AquifMainC = 3.2 ; /* $m for plant of UnitSize rated capacity */
static double AquifUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
AquifUnitSize = 24.0 ;
static long AquifIcap ; /* maximum capacity (GL) */
AquifIcap = 50/AquifUnitSize ; /* Maximum total installed capacity across all plants */
static double TraquifInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostAquif[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostAquif[MaxNodes] ; /* Discount-probability capital cost of building */
/* End aquifer parameters */

/* Recycling specific investment parameters for calculations */
static long RecycInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
RecycInvLag = (3+1)/YearIndex ; /* Lag on the investment */
static long recyclife ; /* life of plant (years) */
recyclife = 50.0/YearIndex ; /* Life of a plant in years */
static double vcrecyc ; /* Unit cost of supplying water ($M per GL) */
vcrecyc = 0.86 ;
static double RecycInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
RecycInvC =  540 ; /* $m for plant of UnitSize rated capacity */
static double RecycMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
RecycMainC =  5 ; /* $m for plant of UnitSize rated capacity */
static double RecycUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
RecycUnitSize = 50.0 ;
static long RecycIcap ; /* maximum capacity (GL) */
RecycIcap = 50/RecycUnitSize ; /* Maximum total installed capacity across all plants */
static double TrrecycInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostRecyc[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostRecyc[MaxNodes] ; /* Discount-probability capital cost of building */
/* End recycling parameters */

/* Tanks specific investment parameters for calculations */
static long TanksInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
TanksInvLag = 0/YearIndex ; /* Lag on the investment */
static long tankslife ; /* life of plant (years) */
tankslife = 20/YearIndex ; /* Life of a plant in years */
static double vctanks ; /* Unit cost of supplying water ($M per GL) */
vctanks = 0.04 ;
static double TanksInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
TanksInvC =  2500.0 ; /* $m for plant of UnitSize rated capacity */
static double TanksMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
TanksMainC =  0 ; /* $m for plant of UnitSize rated capacity */
static double TanksUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
TanksUnitSize = 200.0 ;
static long TanksIcap ; /* maximum capacity (GL) */
TanksIcap = 35/TanksUnitSize ; /* Maximum total installed capacity across all plants */
static double TrtanksInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostTanks[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostTanks[MaxNodes] ; /* Discount-probability capital cost of building */
/* End tanks parameters */

/* Tanks specific investment parameters for calculations */
//static long TanksInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
//TanksInvLag = 2/YearIndex ; /* Lag on the investment */
//static long tankslife ; /* life of plant (years) */
//tankslife = 30/YearIndex ; /* Life of a plant in years */
//static double vctanks ; /* Unit cost of supplying water ($M per GL) */
//vctanks = 0.63 ;
//static double TanksInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
//TanksInvC =  450 ; /* $m for plant of UnitSize rated capacity */
//static double TanksMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
//TanksMainC =  3 ; /* $m for plant of UnitSize rated capacity */
//static double TanksUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
//TanksUnitSize = 50.0 ;
//static long TanksIcap ; /* maximum capacity (GL) */
//TanksIcap = 50/TanksUnitSize ; /* Maximum total installed capacity across all plants */
//static double TrtanksInvC[MaxYears] ; /* truncated cost of investment in capacity */
//static double VarCostTanks[MaxNodes] ; /* Discount-probability cost of operating */
//static double CapCostTanks[MaxNodes] ; /* Discount-probability capital cost of building */
/* End tanks parameters */

/* Trade specific investment parameters for calculations */
static long TradeInvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
TradeInvLag = (3+1)/YearIndex ; /* Lag on the investment */
static long tradelife ; /* life of plant (years) */
tradelife = 80/YearIndex ; /* Life of a plant in years */
static double vctrade ; /* Unit cost of supplying water ($M per GL) */
vctrade = 1.00 ;
static double TradeInvC ; /* Investment cost of plant of UnitSize capacity ($M) */
TradeInvC =  157.0 ; /* $m for plant of UnitSize rated capacity */
static double TradeMainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
TradeMainC =  0 ; /* $m for plant of UnitSize rated capacity */
static double TradeUnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
TradeUnitSize = 10.0 ;
static long TradeIcap ; /* maximum capacity (GL) */
TradeIcap = 1000/TradeUnitSize ; /* Maximum total installed capacity across all plants */
static double TrtradeInvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostTrade[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostTrade[MaxNodes] ; /* Discount-probability capital cost of building */
static double TradePr[MaxStates] ; /* Trade price for each contingent state */
TradePr[1] = 1.00 ; /* contingent state 1 */
TradePr[2] = 1.00 ; /* contingent state 2 */
TradePr[3] = 1.00 ; /* contingent state 3 */
static double TradePrNd[MaxNodes] ; /* Inlow weight for each node in each stage of the decision tree */
/* End trade parameters */

/* Large aquifer specific investment parameters for calculations */
static long Aquif2InvLag ; /* Lag (in years) between decision to invest and the commissioning of the plant */ 
Aquif2InvLag = (3+1)/YearIndex ; /* Lag on the investment */
static long Aquif2life ; /* life of plant (years) */
Aquif2life = 50/YearIndex ; /* Life of a plant in years */
static double vcAquif2 ; /* Unit cost of supplying water ($M per GL) */
vcAquif2 = 0.40 ;
static double Aquif2InvC ; /* Investment cost of plant of UnitSize capacity ($M) */
Aquif2InvC =  729 ; /* $m for plant of UnitSize rated capacity */
static double Aquif2MainC ; /* Annual maintenance cost of plant of UnitSize capacity ($M) */
Aquif2MainC =  7 ; /* $m for plant of UnitSize rated capacity */
static double Aquif2UnitSize ; /* Unit size (rated capacity) of plants (GL per year) */
Aquif2UnitSize = 45.0 ;
static long Aquif2Icap ; /* maximum capacity (GL) */
Aquif2Icap = 45/Aquif2UnitSize ; /* Maximum total installed capacity across all plants */
static double TrAquif2InvC[MaxYears] ; /* truncated cost of investment in capacity */
static double VarCostAquif2[MaxNodes] ; /* Discount-probability cost of operating */
static double CapCostAquif2[MaxNodes] ; /* Discount-probability capital cost of building */
/* End Aquif2 parameters */


static double LRAICdesal ; /* LRAIC of supply from desal used as the imputed price for storage in the terminal period */
LRAICdesal = DesalInvC/DesalUnitSize*discount/(1.0-pow(1.0/(1.0+discount),desallife)) + DesalMainC/DesalUnitSize + vcdesal + utcdam ;
static double LRAICaquif ; /* LRAIC of supply from aquifers used as the imputed price for storage in the terminal period */
LRAICaquif = AquifInvC/AquifUnitSize*discount/(1.0-pow(1.0/(1.0+discount),aquiflife)) + AquifMainC/AquifUnitSize + vcaquif + utcdam ;
static double LRAICrecyc ; /* LRAIC of supply from recycling used as the imputed price for storage in the terminal period */
LRAICrecyc = RecycInvC/RecycUnitSize*discount/(1.0-pow(1.0/(1.0+discount),recyclife)) +RecycMainC/RecycUnitSize + vcrecyc + utcdam ;
static double LRAICtrade ; /* LRAIC of supply from trade used as the imputed price for storage in the terminal period */
LRAICtrade = TradeInvC/TradeUnitSize*discount/(1.0-pow(1.0/(1.0+discount),tradelife)) +TradeMainC/TradeUnitSize + vctrade + utcdam ;

uvts = LRAICtrade - utcdam - vcdam ;

//
// compute the number of scenarios and nodes
//
NScen = long(powl(NS, NT)) ;
NNodes = (long(powl(NS,NT+1))-NS)/(NS-1) ;
CreateGamsCode <<"NScen = " << NScen << endl ;
CreateGamsCode <<"NNodes = " << NNodes << endl ;
//
// open each GAMS file being created and declare the contents (set or parameter)
//
ofstream Sets("Sets.gms") ;  // Sets definitions //
  Sets <<"Set Yr time periods / Yr1*Yr" << NT << " / ;" <<endl ; // declare set Yr
  Sets <<"  Alias(Yr,YrP,YrPP) ;" << endl ; // declare alias for set Yr
  Sets <<"Set N  all nodes in the decision tree / N1*N" << NNodes << " / ;" <<endl ; // declare set Yr
  Sets <<"  Alias(N,NP,NPP) ;" << endl ; // declare alias for set N
  Sets <<"Set S maximum set of contingent states in any time period / s1*s" << NS << " / ;" <<endl ; // declare set S
  Sets <<"Set L linearised points for demand functions / L1*L" << L << " / ;" <<endl ; // declare set L
  Sets <<"Set M linearised points for terminal storage demand functions / M1*M" << M << " / ;" <<endl ; // declare set M
  Sets <<"Set D Users in the demand function / D1*D" << D << " / ;" <<endl ; // declare set D
ofstream Scalars("Scalars.gms") ;  // Scalars required in model constraints //
  Scalars <<"Scalar MaxS0 Maximum storage capacity of dams (GL) / " << MaxS0 << " / ;" <<endl ; // declare maximum dam storage capacity //
  Scalars <<"Scalar MinS0 Minimum storage capacity of dams (GL) / " << MinS0 << " / ;" <<endl ; // declare minimum dam storage capacity //
  Scalars <<"Scalar S0 Initial storage in dams (rolled in to inflows) (GL) / " << S0 << " / ;" <<endl ; // declare intial dam storage //
  Scalars <<"Scalar EvapLoss Evaporation Loss from dams / " << EvapLoss << " / ;" <<endl ; // declare evaporation loss //
  Scalars <<"Scalar YearIndex Number of years in each time period / " << YearIndex << " / ;" <<endl ; // Number of years in each time period //
  Scalars <<"Scalar MultiYear Objective function coefficient for time period / " << MultiYear << " / ;" <<endl ; // Objective function coefficient for each time period //
  Scalars <<"Scalar MAvg Number of years in each time period / " << MAvg << " / ;" <<endl ; // Number of years for moving average //
ofstream DF("DF.gms") ;  // Parameter DF(T) Discount factor for each year //
  DF <<"Parameter Df(Yr) Discount factor for each year" <<endl ; // declare the parameter Df //
ofstream GF("GF.gms") ;  // Parameter GF(T) growth factor for each year //
  GF <<"Parameter Gf(Yr) Growth factor for each year" <<endl ; // declare the parameter Gf //
ofstream YrNd("YrNd.gms") ;  // Set YrNd(Yr,N) Nodes by year //
  YrNd <<"Set YrNd(Yr,N) Nodes by year" <<endl ; // declare the set YrNd //
ofstream LastYrNd("LastYrNd.gms") ;  // Set LastYrNd(Yr,N) Nodes in the last year //
  LastYrNd <<"Set LastYrNd(Yr,N) Nodes in the last year" <<endl ; // declare the set LastYrNd //
ofstream ChildParent("ChildParent.gms") ;  // Set ChildParent(Yr,N,YrP,NP) Ancestor-Successor (parent-child) nodes //
  ChildParent <<"Set ChildParent(Yr,N,YrP,NP) Ancestor-Successor (parent-child) nodes" <<endl ; // declare the set ChildParent //
ofstream Desal2ProdnYrNd("Desal2ProdnYrNd.gms") ;  // Set Desal2ProdnYrNd(Yr,N) Nodes in which production is possible //
  Desal2ProdnYrNd <<"Set Desal2ProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream ScenMap("ScenMap.gms") ;  // Set ScenMap(Yr,N,YrP,NP) Nodes for each scenario (leaf) in the decision tree for GAMS //
  ScenMap <<"Set ScenMap(Yr,N,YrP,NP) Nodes for each scenario (leaf) in the decision tree " <<endl ; // declare the set ScenMap //
ofstream ScenMapSas("ScenMapSas.txt") ;  // Output text file for use by SAS //
ofstream AquiAvgMap1("AquiAvgMap1.gms") ;  // Set Aqui5yrAvg (Yr,N,YrP,NP) Nodes for 5 year moving average (block 1) //
  AquiAvgMap1 <<"Set AquiAvgMap1(Yr,N,YrP,NP) Scenario mapping nodes for 5 year moving average aquifer drawdown " <<endl ; // declare the set ScenMap //
ofstream AquiAvgMap2("AquiAvgMap2.gms") ;  // Set Aqui5yrAvg (Yr,N,YrP,NP) Nodes for 5 year moving average (block 2) //
  AquiAvgMap2 <<"Set AquiAvgMap2(Yr,N,YrP,NP) Scenario mapping nodes for 5 year moving average aquifer drawdown (terminal)" <<endl ; // declare the set ScenMap //
ofstream AquiAvgMap3("AquiAvgMap3.gms") ;  // Set Aqui5yrAvg (Yr,N,YrP,NP) Nodes for 5 year moving average (block 3) //
  AquiAvgMap3 <<"Set AquiAvgMap3(Yr,N,YrP,NP) Scenario mapping nodes for 5 year moving average aquifer drawdown (terminal)" <<endl ; // declare the set ScenMap //
ofstream AquiAvgMap4("AquiAvgMap4.gms") ;  // Set Aqui5yrAvg (Yr,N,YrP,NP) Nodes for 5 year moving average (block 4) //
  AquiAvgMap4 <<"Set AquiAvgMap4(Yr,N,YrP,NP) Scenario mapping nodes for 5 year moving average aquifer drawdown (terminal)" <<endl ; // declare the set ScenMap //
ofstream InflowAtNode("InflowAtNode.gms") ;  // parameter InflowAtNode(Yr,N)  Contingent state inflow at each node //
  InflowAtNode <<"parameter InflowAtNode(Yr,N)  Contingent state inflow at each node" <<endl ; // declare the parameter InflowAtNode //
ofstream CumInflowAtNode("CumInflowAtNode.gms") ;  // parameter CumInflowAtNode(Yr,N)  Cumulative contingent state inflow at each node //
  CumInflowAtNode <<"parameter CumInflowAtNode(Yr,N)  Cumulative contingent state inflow at each node" <<endl ; // declare the parameter CumInflowAtNode //
ofstream CondProb("CondProb.gms") ;  // parameter CondProb(Yr,N)  Conditional probability at each node //
  CondProb <<"parameter Condprob(Yr,N)  Conditional probability at each node" <<endl ; // declare the parameter CondProb //
ofstream OpExDam("OpExDam.gms") ;  // Parameter OpExDam(Yr,N) Discount-probability weighted operating cost of dam //
  OpExDam <<"Parameter OpExDam(Yr,N) Discount-probability weighted operating cost of dam" <<endl ; // declare the parameter OpExDam //
ofstream OpExDesal1("OpExDesal1.gms") ;  // Parameter OpExDesal1(Yr,N) Discount-probability weighted operating cost of existing desal (Kwinana) //
  OpExDesal1 <<"Parameter OpExDesal1(Yr,N) Discount-probability weighted operating cost of existing desal (Kwinana)" <<endl ; // declare the parameter OpExDesal1 //
ofstream OpExDesal2("OpExDesal2.gms") ;  // Parameter OpExDesal2(Yr,N) Discount-probability weighted operating cost of existing desal (Southern) //
  OpExDesal2 <<"Parameter OpExDesal2(Yr,N) Discount-probability weighted operating cost of existing desal (Southern)" <<endl ; // declare the parameter OpExDesal2 //
ofstream OpExAquif0("OpExAquif0.gms") ;  // Parameter OpExAquif0(Yr,N) Discount-probability weighted operating cost of existing aquifers //
  OpExAquif0 <<"Parameter OpExAquif0(Yr,N) Discount-probability weighted operating cost of existing aquifers" <<endl ; // declare the parameter OpExAquif0 //
ofstream Area("Area.gms") ;  // parameter Area(Yr,N,D,L)  Discount-probability weighted OF coefficient for each linearised demand point //
  Area <<"Parameter Area(Yr,N,D,L) Discount-probability weighted OF coefficient for each linearised demand point" <<endl ; // declare the parameter Area //
ofstream Qty("Qty.gms") ;  // parameter Qty(Yr,N,D,L)  Quantity coefficient for each linearised demand point //
  Qty <<"Parameter Qty(Yr,N,D,L) Quantity coefficient for each aggregated linearised demand point" <<endl ; // declare the parameter Qty //
ofstream AggArea("AggArea.gms") ;  // parameter AggArea(Yr,N,L)  Discount-probability weighted OF coefficient for each linearised demand point //
  AggArea <<"Parameter AggArea(Yr,N,L) Discount-probability weighted OF coefficient for each linearised demand point" <<endl ; // declare the parameter AggArea //
ofstream AggQty("AggQty.gms") ;  // parameter AggQty(Yr,N,L)  Quantity coefficient for each aggregated linearised demand point //
  AggQty <<"Parameter AggQty(Yr,N,L) Quantity coefficient for each aggregated linearised demand point" <<endl ; // declare the parameter AggQty //
ofstream Dprice("Dprice.gms") ;  // parameter Dprice(Yr,N,D,L)  Price for each linearised demand point //
  Dprice <<"Parameter Dprice(Yr,N,D,L) Price for each linearised demand point" <<endl ; // declare the parameter Dprice //
ofstream AggDprice("AggDprice.gms") ;  // parameter AggDprice(Yr,N,L)  Price for each linearised aggregate demand point //
  AggDprice <<"Parameter AggDprice(Yr,N,L) Price for each linearised aggregate demand point" <<endl ; // declare the parameter AggDprice //
ofstream TSP("TSP.gms") ;  // Parameter TermStorPrice(Yr,N) Discount-probability weighted price of terminal storage in dams //
  TSP <<"Parameter TermStorPrice(Yr,N) Discount-probability weighted price of terminal storage in dams" <<endl ; // declare the parameter TSP //
ofstream AreaTS("AreaTS.gms") ;  // parameterAreaTS(Yr,N,M)  Discount-probability weighted OF coefficient for each linearised terminal storage demand point //
  AreaTS <<"Parameter AreaTS(Yr,N,M) Discount-probability weighted OF coefficient for each linearised terminal storage demand point" <<endl ; // declare the parameter AreaTS //
ofstream QtyTS("QtyTS.gms") ;  // parameter QtyTS(Yr,N,M)  Quantity coefficient for each aggregated linearised terminal storage demand point //
  QtyTS <<"Parameter QtyTS(Yr,N,M) Quantity coefficient for each aggregated linearised demand point" <<endl ; // declare the parameter QtyTS //
ofstream PriceLinTS("PriceTS.gms") ;  // parameterPriceTS(Yr,N,M)  Pricet for each aggregated linearised terminal storage demand point //
  PriceLinTS <<"Parameter PriceTS(Yr,N,M) Price for each aggregated linearised demand point" <<endl ; // declare the parameter PriceTS //
ofstream AreaTSRest("AreaTSRest.gms") ;  // parameter AreaTSRest(Yr,N,M)  Discount-probability weighted OF coefficient for each linearised terminal storage demand point //
  AreaTSRest <<"Parameter AreaTSRest(Yr,N,M) Discount-probability weighted OF coefficient for each linearised terminal storage demand point with restrictions" <<endl ; // declare the parameter AreaTSRest //

/* Desal streams */
ofstream DesalProdnYrNd("DesalProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  DesalProdnYrNd <<"Set DesalProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream DesalCapLastYrNd("DesalCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  DesalCapLastYrNd <<"Set DesalCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream DesalCapInv("DesalCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  DesalCapInv <<"Set DesalCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream DesalCapMap("DesalCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  DesalCapMap<<"Set DesalCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream DesalCapMaxMap("DesalCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  DesalCapMaxMap <<"set DesalCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  DesalIcap maximum desal capacity (GL) / " << DesalIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  DesalUnitSize Water manufacturing capacity of each plant (GL per year) / " << DesalUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExDesal("OpExDesal.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExDesal <<"Parameter OpExDesal(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExDesal("CapExDesal.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExDesal <<"Parameter CapExDesal(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream DesalPlantCap("DesalPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream DesalScenMapSas("DesalScenMapSas.txt") ;  // Output text file for use by SAS //
/* End desal streams */

/* Aquif streams */
ofstream AquifProdnYrNd("AquifProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  AquifProdnYrNd <<"Set AquifProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream AquifCapLastYrNd("AquifCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  AquifCapLastYrNd <<"Set AquifCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream AquifCapInv("AquifCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  AquifCapInv <<"Set AquifCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream AquifCapMap("AquifCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  AquifCapMap<<"Set AquifCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream AquifCapMaxMap("AquifCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  AquifCapMaxMap <<"set AquifCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  AquifIcap maximum Aquif capacity (GL) / " << AquifIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  AquifUnitSize Water manufacturing capacity of each plant (GL per year) / " << AquifUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExAquif("OpExAquif.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExAquif <<"Parameter OpExAquif(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExAquif("CapExAquif.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExAquif <<"Parameter CapExAquif(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream AquifPlantCap("AquifPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream AquifScenMapSas("AquifScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Aquif streams */

/* Recyc streams */
ofstream RecycProdnYrNd("RecycProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  RecycProdnYrNd <<"Set RecycProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream RecycCapLastYrNd("RecycCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  RecycCapLastYrNd <<"Set RecycCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream RecycCapInv("RecycCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  RecycCapInv <<"Set RecycCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream RecycCapMap("RecycCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  RecycCapMap<<"Set RecycCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream RecycCapMaxMap("RecycCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  RecycCapMaxMap <<"set RecycCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  RecycIcap maximum Recyc capacity (GL) / " << RecycIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  RecycUnitSize Water manufacturing capacity of each plant (GL per year) / " << RecycUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExRecyc("OpExRecyc.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExRecyc <<"Parameter OpExRecyc(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExRecyc("CapExRecyc.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExRecyc <<"Parameter CapExRecyc(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream RecycPlantCap("RecycPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream RecycScenMapSas("RecycScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Recyc streams */

/* Tanks streams */
ofstream TanksProdnYrNd("TanksProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  TanksProdnYrNd <<"Set TanksProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream TanksCapLastYrNd("TanksCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  TanksCapLastYrNd <<"Set TanksCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream TanksCapInv("TanksCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  TanksCapInv <<"Set TanksCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream TanksCapMap("TanksCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  TanksCapMap<<"Set TanksCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream TanksCapMaxMap("TanksCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  TanksCapMaxMap <<"set TanksCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  TanksIcap maximum Tanks capacity (GL) / " << TanksIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  TanksUnitSize Water manufacturing capacity of each plant (GL per year) / " << TanksUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExTanks("OpExTanks.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExTanks <<"Parameter OpExTanks(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExTanks("CapExTanks.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExTanks <<"Parameter CapExTanks(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream TanksPlantCap("TanksPlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream TanksScenMapSas("TanksScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Tanks streams */

/* Trade streams */
ofstream TradeProdnYrNd("TradeProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  TradeProdnYrNd <<"Set TradeProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream TradeCapLastYrNd("TradeCapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  TradeCapLastYrNd <<"Set TradeCapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream TradeCapInv("TradeCapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  TradeCapInv <<"Set TradeCapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream TradeCapMap("TradeCapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  TradeCapMap<<"Set TradeCapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream TradeCapMaxMap("TradeCapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  TradeCapMaxMap <<"set TradeCapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  TradeIcap maximum Trade capacity (GL) / " << TradeIcap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  TradeUnitSize Water manufacturing capacity of each plant (GL per year) / " << TradeUnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExTrade("OpExTrade.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExTrade <<"Parameter OpExTrade(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExTrade("CapExTrade.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExTrade <<"Parameter CapExTrade(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream TradePlantCap("TradePlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream TradeScenMapSas("TradeScenMapSas.txt") ;  // Output text file for use by SAS //
ofstream TradePrNdOut("TradePrNdOut.gms") ;  // parameter TradePrNdOut(Yr,N)  Trade price at each node //
  TradePrNdOut <<"parameter TradePrNdOut(Yr,N)  Trade price at each node" <<endl ; // declare the parameter TradePrNdOut //
/* End Trade streams */

/* Aquif2 streams */
ofstream Aquif2ProdnYrNd("Aquif2ProdnYrNd.gms") ;  // Set ProdnYrNd(Yr,N) Nodes in which production is possible //
  Aquif2ProdnYrNd <<"Set Aquif2ProdnYrNd(Yr,N) Nodes in which production is possible" <<endl ; // declare the set ProdnYrNd //
ofstream Aquif2CapLastYrNd("Aquif2CapLastYrNd.gms") ;  // Set CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible //
  Aquif2CapLastYrNd <<"Set Aquif2CapLastYrNd(Yr,N) Nodes in last year in which augmentation of capacity is possible" <<endl ; // declare the set CapLastYrNd //
ofstream Aquif2CapInv("Aquif2CapInv.gms") ;  // Set CapInv(Yr,N) Nodes in which investment can occur over time //
  Aquif2CapInv <<"Set Aquif2CapInv(Yr,N) Nodes in which investment can occur over time" <<endl ; // declare the set CapInv //
ofstream Aquif2CapMap("Aquif2CapMap.gms") ;  // Set CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it //
  Aquif2CapMap<<"Set Aquif2CapMap(Yr,N,YrP,NP) mapping of capacity addition to future water supplies from it" <<endl ; // declare the set CapMap //
ofstream Aquif2CapMaxMap("Aquif2CapMaxMap.gms") ;  // set CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint //
  Aquif2CapMaxMap <<"set Aquif2CapMaxMap(Yr,N,YrP,NP)  mapping of capacity additions to the max capacity constraint" <<endl ; // declare the set CapMaxMap //
  Scalars <<"Scalar  Aquif2Icap maximum Aquif2 capacity (GL) / " << Aquif2Icap << " / ;" <<endl ; // declare augmentation capacity //
  Scalars <<"Scalar  Aquif2UnitSize Water manufacturing capacity of each plant (GL per year) / " << Aquif2UnitSize << " / ;" << endl ; // declare the scalar UnitSize //  
ofstream OpExAquif2("OpExAquif2.gms") ;  // Parameter OpEx(Yr,N) Discount-probability weighted operating cost //
  OpExAquif2 <<"Parameter OpExAquif2(Yr,N) discount-probability weighted operating cost" <<endl ; // declare the parameter OpEx //
ofstream CapExAquif2("CapExAquif2.gms") ;  // Parameter CapEx(Yr,N) Discount-probability weighted capital cost //
  CapExAquif2 <<"Parameter CapExAquif2(Yr,N) Discount-probability weighted capital cost" <<endl ; // declare the parameter CapEx //
ofstream Aquif2PlantCap("Aquif2PlantCap.gms") ;  // Parameter PlantCap(Yr,N) Water manufacturing capacity of each plant (GL per year) //
ofstream Aquif2ScenMapSas("Aquif2ScenMapSas.txt") ;  // Output text file for use by SAS //
/* End Aquif2 streams */

//
// compute the required information for each node in the decision tree
//
//
// calculate the basic or summary information for each year of the decision tree
//
for (T = 1; T <= NT; T++) {     /* loop over each year */ 
  nat[T] = long(powl(NS,T)) ;  /* calculate the number of nodes in each specific year (scenarios for each year) */
  cumnat[T] = (long(powl(NS,T+1))-long(powl(NS,1)))/(NS-1) ;  /* calculate the cumulative number of nodes for each year */ 
  NumScenYr[T] = long(powl(NS,NT-T)) ;  /* calculate the number of forward scenarios for a node in each year  */ 
  CumNumScenYr[T] = (long(powl(NS,NT+1-T))-long(powl(NS,1)))/(NS-1) ; /* Cumulative number of forward nodes for a node in each year */
  gf[T] = pow(1.0+growth,MultiYear*(double(T)-1.0)) ;
  Df[T] = pow(1.0+discount,MultiYear*(1.0-double(T))) ;
  //
  // Write to file DF and GF
  //
  if (T == 1) {
    DF <<"  / Yr" << T << " = " << Df[T] << "," << endl ;
	GF <<"  / Yr" << T << " = " << gf[T] << "," << endl ;
  }
  else if (T == NT) {
    DF <<"    Yr" << T << " = " << Df[T] << " / ;" << endl ;
	GF <<"    Yr" << T << " = " << gf[T] << " / ;" << endl ;
  }
  else {
    DF <<"    Yr" << T << " = " << Df[T] << "," << endl ;
	GF <<"    Yr" << T << " = " << gf[T] << "," << endl ;
  } ;
  if (T <= NT - DesalInvLag) {  
    TrdesalInvC[T] =
	   (DesalInvC/(1.0-1.0/pow(1.0+discount,double(desallife)))+DesalMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(DesalInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(DesalInvLag)))) ;
  } ;
  if (T <= NT - AquifInvLag) {  
    TraquifInvC[T] =
	   (AquifInvC/(1.0-1.0/pow(1.0+discount,double(aquiflife)))+AquifMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(AquifInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(AquifInvLag)))) ;
  } ;
  if (T <= NT - RecycInvLag) {  
    TrrecycInvC[T] =
	   (RecycInvC/(1.0-1.0/pow(1.0+discount,double(recyclife)))+RecycMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(RecycInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(RecycInvLag)))) ;
  } ;
  if (T <= NT - TanksInvLag) {  
    TrtanksInvC[T] =
	   (TanksInvC/(1.0-1.0/pow(1.0+discount,double(tankslife)))+TanksMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(TanksInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(TanksInvLag)))) ;
  } ;
  if (T <= NT - TradeInvLag) {  
    TrtradeInvC[T] =
	   (TradeInvC/(1.0-1.0/pow(1.0+discount,double(tradelife)))+TradeMainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(TradeInvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(TradeInvLag)))) ;
  } ;
  if (T <= NT - Aquif2InvLag) {  
    TrAquif2InvC[T] =
	   (Aquif2InvC/(1.0-1.0/pow(1.0+discount,double(Aquif2life)))+Aquif2MainC/(1.0-1.0/(1.0+discount)))
	  *(1.0-1.0/pow(1.0+discount,double(NT)-double(T)-double(Aquif2InvLag)+1.0))
	  *(1.0/pow(1.0+discount,(double(T)-1.0+double(Aquif2InvLag)))) ;
  } ;
  x = 0.0 ;
  y = 0.0 ;
  for (I=1; I<=D; I++) {
    bglin[T][I] = blin[I]/gf[T] ;
    x = x - alin[I]/bglin[T][I] ;
    y = y + 1.0/bglin[T][I] ;
  } ;
  Alpha[T] = -(x)/y ;
  Beta[T] = 1.0/y ;
  CreateGamsCode << "Year = " << T << ", Alpha = " << Alpha[T] << ", Beta = " << Beta[T] << endl ;
} ;
//
// for the nodes in year 1, assign the inflows and probabilities
//
for (I = 1; I <= NS; I++) {
  Cr[I] = inflow[I]*EVinflow + S0 ;
  CumR[I] = inflow[I]*EVinflow ;
  Cp[I] = prob[I] ;
  P[I] = prob[I] ;
  VarCostDam[I] = Df[1]*Cp[I]*(utcdam+vcdam) ;
  VarCostDesal1[I] = Df[1]*Cp[I]*(utcdam+vcdesal1) ;
  VarCostAquif0[I] = Df[1]*Cp[I]*(utcdam+vcaquif0) ;
  TradePrNd[I] = TradePr[I] ;
} ;
//
// Calculate the node information
//
count = 0 ; /* initialise the node count to zero */ 
for (T = 1; T <= NT; T++) {     /* loop over each year */
  cout <<"Doing year = " << T << endl ;
  for(I = 1; I <= nat[T]; I++) {  /* loop over the nodes in each year */
    count = count + 1 ;  /* count the nodes as we loop over years and number of nodes in each */
    Nodes[count] = count ;  /* assign a node number to each node */
    NodeTime[count] = T ;  /* assign a year to each node */ 
    NodeAT[count] = I ;  /* assign a number to each node representing its number (or scenario) for the specific year in which it occurs */
	// cout << "Estimated time remaining: " << 1 + int( (1 - float(count)/float(NNodes))/(float(count)/float(NNodes))*(clock()*CLK_TCK-StartTime*CLK_TCK)/1000000 ) << " seconds. (Year " << T << ", Node " << count << ", of total nodes " << NNodes << ")" << endl ;    
	x = double(NodeAT[count]) ;
    if (fmod(x, double(NS)) == 0) {
      StateAtNode[count] = 3 ;
    }
    else {
      StateAtNode[count] = long (fmod(x, double(NS))) ;
    } ;
    //
    //  write records to file YrNd
    //
    if (count == 1) {
      YrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count > 1 && count < NNodes) {
      YrNd <<"    Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count == NNodes) {
      YrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
    } ;

	//
	// calculate and write the long-run marginal cost pricing block nodes TIM
	//

	if(NodeAT[count] == 1) {
		if( ((T-1) % block_length) == 0 ) {
			start_block ++ ;
			total_block ++ ;
			block = total_block ;
			start_block = total_block ;
			// cout << start_block << " start " << total_block << " total " << total_block << " using " << endl ;
		} ;
		if( ((T-1) % block_length) != 0 ) {
			block = start_block ;
			// cout << start_block << " start " << total_block << " total " << start_block << " using " << endl ;
		} ;
		bcount = 0 ;
	} ;
	if(bcount == long long (powf(NS , (((T - 1) % block_length) + 1))) ) {
		if( ((T-1) % block_length) == 0 ) {
			total_block ++ ;
		} ;
		block ++ ;
		bcount = 0 ;
	};
	bcount ++ ;	
//    cout << start_block << " start " << total_block << " total " << endl ;


    if (count == 1) {
      NdPrBlk <<"  / Yr" << T << ".N" << count << ".P" << block << "," << endl ;
    } 
    else if (count > 1 && count < NNodes) {
      NdPrBlk <<"    Yr" << T << ".N" << count << ".P" << block << "," << endl ;
    } 
    else if (count == NNodes) {
      NdPrBlk <<"    Yr" << T << ".N" << count << ".P" << block << " / ;" << endl ;
	  Sets <<"Set PrBlk Number of pricing blocks / P1*P" << block << " / ;" <<endl ; // declare set PrBlk
    } ;


    //
    //  write records to file CapLastYrNd
    //
    if (T == NT - DesalInvLag) {
      if (count == cumnat[T-1] + 1) {
        DesalCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        DesalCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        DesalCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - AquifInvLag) {
      if (count == cumnat[T-1] + 1) {
        AquifCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        AquifCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        AquifCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - RecycInvLag) {
      if (count == cumnat[T-1] + 1) {
        RecycCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        RecycCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        RecycCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - TanksInvLag) {
      if (count == cumnat[T-1] + 1) {
        TanksCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        TanksCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        TanksCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - TradeInvLag) {
      if (count == cumnat[T-1] + 1) {
        TradeCapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        TradeCapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        TradeCapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    if (T == NT - Aquif2InvLag) {
      if (count == cumnat[T-1] + 1) {
        Aquif2CapLastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count > cumnat[T-1] + 1 && count < cumnat[T]) {
        Aquif2CapLastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
      } 
      else if (count == cumnat[T]) {
        Aquif2CapLastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
      } 
    } ;
    //
    //  write records to files InflowAtNode, CondProb, OpEx, OpExDam, OpExDesal1 and OpExAquif0 for nodes in the first year
    //
    if (T == 1 && count == 1) {
      InflowAtNode <<"  / Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
	  CumInflowAtNode <<"  / Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
      TradePrNdOut <<"  / Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ;
	  CondProb <<"  / Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      OpExDam << "  / Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
	  OpExDesal1 << "  / Yr" << T << ".N" << count << " = " << VarCostDesal1[count] << "," << endl ;
	  OpExAquif0 << "  / Yr" << T << ".N" << count << " = " << VarCostAquif0[count] << "," << endl ;
    } 
    else if (T == 1 && count > 1 ) {
      InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
      CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
	  TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ;
      CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
	  OpExDesal1 << "    Yr" << T << ".N" << count << " = " << VarCostDesal1[count] << "," << endl ;
	  OpExAquif0 << "    Yr" << T << ".N" << count << " = " << VarCostAquif0[count] << "," << endl ;
    } ;
    if (T > 1) {          /* do the following calculations for nodes not in the first year (ie strictly child nodes) */
      x = double(double(count)/double(NS)) ;
      ParNodeNumber[count] = long ((ceil(x)) - 1) ; /* calculate the parent node number of the current child node */  
      ParNodeTime[count] = T-1 ;    /* assign the year of the parent node */
      ParNodeNat[count] = NodeAT[ParNodeNumber[count]] ; /* assign the parent node number for its year */
      ChildNodeNumber[StateAtNode[count]][ParNodeNumber[count]] = count ; /* assign the child node number to the parent node */
      ChildNodeTime[StateAtNode[count]][ParNodeNumber[count]] = T ; /* assign the child year to the parent node */
      ChildNodeNat[StateAtNode[count]][ParNodeNumber[count]] = I ; /* assign the child node number in its year to the parent node */
      Cr[count] = inflow[StateAtNode[count]]*EVinflow ;  /* assign the contingent inflow to the child node */
      CumR[count] = CumR[ParNodeNumber[count]] + inflow[StateAtNode[count]]*EVinflow ;  /* calculate and assign assign the cumulative contingent inflow to the child node */
      TradePrNd[count] = TradePr[StateAtNode[count]] ;
	  Cp[count] = Cp[ParNodeNumber[count]] * prob[StateAtNode[count]] ;  /* calculate and assign the conditional probability of the child node */ 
      P[count] = prob[StateAtNode[count]] ;  /* assign the contingent state probability to the child node */
      VarCostDam[count] = Df[T]*Cp[count]*(utcdam+vcdam) ;
      VarCostDesal1[count] = Df[T]*Cp[count]*(utcdam+vcdesal1) ;
	  VarCostAquif0[count] = Df[T]*Cp[count]*(utcdam+vcaquif0) ;
      //
      // Write records to file OpExDam, OpExDesal1, OpexDesal2, OpExAquif0
      //
      if (count == NNodes) {
        OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << " / ;" << endl ;
		OpExDesal1 << "    Yr" << T << ".N" << count << " = " << VarCostDesal1[count] << " / ;" << endl ;
		OpExAquif0 << "    Yr" << T << ".N" << count << " = " << VarCostAquif0[count] << " / ;" << endl ;
      } 
      else {
        OpExDam << "    Yr" << T << ".N" << count << " = " << VarCostDam[count] << "," << endl ;
		OpExDesal1 << "    Yr" << T << ".N" << count << " = " << VarCostDesal1[count] << "," << endl ;
		OpExAquif0 << "    Yr" << T << ".N" << count << " = " << VarCostAquif0[count] << "," << endl ;
      } ;


      if (T == NT) {
        PriceWaterStored[count] = uvts*Df[T]*Cp[count]/(1+discount) ;
        //
        // Write records to file TSP
        //
        if (count == cumnat[NT-1] + 1) {
          TSP <<"  / Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << "," << endl ;
        } 
        else if (count > cumnat[NT-1] + 1 && count < NNodes) {
          TSP <<"    Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << "," << endl ;
        } 
        else if (count == NNodes) {
          TSP <<"    Yr" << T << ".N" << count << " = " << PriceWaterStored[count] << " / ;" << endl ;
        } ;
      } ;
      //
      //  write records to file ChildParent
      //
	  if (count == cumnat[1]+1) {
        ChildParent <<"  / Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        ChildParent <<"    Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << " / ;"<< endl ;
      }
      else if (count > cumnat[1]+1 && count < NNodes) {
        ChildParent <<"    Yr" << T << ".N" << count << ".Yr" <<  T-1 << ".N" << ParNodeNumber[count] << "," << endl ;
      }  ;
      //
      //  write records to files InflowAtNode and CondProb for nodes not in the first year
      //
      if (count < NNodes) {
        InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << "," << endl ;
        CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << "," << endl ;
        TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << "," << endl ;
		CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << "," << endl ;
      } 
      else if (count == NNodes ) {
        InflowAtNode <<"    Yr" << T << ".N" << count << " = "<< Cr[count] << " / ;" << endl ;
        CumInflowAtNode <<"    Yr" << T << ".N" << count << " = "<< CumR[count] << " / ;" << endl ;
        TradePrNdOut <<"    Yr" << T << ".N" << count << " = "<< TradePrNd[count] << " / ;" << endl ;
		CondProb <<"    Yr" << T << ".N" << count << " = "<< Cp[count] << " / ;" << endl ;
      } ;
    } ;
    //
    //  write records to file CapInv and CapEx
    //
    if (T <= NT - DesalInvLag) {
	  CapCostDesal[count] = TrdesalInvC[T]*Cp[count] ;
      if (count == 1) {
        DesalCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExDesal << "  / Yr" << T << ".N" << count << " = " << CapCostDesal[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-DesalInvLag]) {
        DesalCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExDesal << "    Yr" << T << ".N" << count << " = " << CapCostDesal[count] << " / ;" << endl ;
      } 
      else {
        DesalCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExDesal << "    Yr" << T << ".N" << count << " = " << CapCostDesal[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - AquifInvLag) {
	  CapCostAquif[count] = TraquifInvC[T]*Cp[count] ;
      if (count == 1) {
        AquifCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExAquif << "  / Yr" << T << ".N" << count << " = " << CapCostAquif[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-AquifInvLag]) {
        AquifCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExAquif << "    Yr" << T << ".N" << count << " = " << CapCostAquif[count] << " / ;" << endl ;
      } 
      else {
        AquifCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExAquif << "    Yr" << T << ".N" << count << " = " << CapCostAquif[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - RecycInvLag) {
	  CapCostRecyc[count] = TrrecycInvC[T]*Cp[count] ;
      if (count == 1) {
        RecycCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExRecyc << "  / Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-RecycInvLag]) {
        RecycCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExRecyc << "    Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << " / ;" << endl ;
      } 
      else {
        RecycCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExRecyc << "    Yr" << T << ".N" << count << " = " << CapCostRecyc[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - TanksInvLag) {
	  CapCostTanks[count] = TrtanksInvC[T]*Cp[count] ;
      if (count == 1) {
        TanksCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExTanks << "  / Yr" << T << ".N" << count << " = " << CapCostTanks[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-TanksInvLag]) {
        TanksCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExTanks << "    Yr" << T << ".N" << count << " = " << CapCostTanks[count] << " / ;" << endl ;
      } 
      else {
        TanksCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExTanks << "    Yr" << T << ".N" << count << " = " << CapCostTanks[count] << "," << endl ;
      } 
    } ;
    if (T <= NT - TradeInvLag) {
	  CapCostTrade[count] = TrtradeInvC[T]*Cp[count] ;
      if (count == 1) {
        TradeCapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExTrade << "  / Yr" << T << ".N" << count << " = " << CapCostTrade[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-TradeInvLag]) {
        TradeCapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExTrade << "    Yr" << T << ".N" << count << " = " << CapCostTrade[count] << " / ;" << endl ;
      } 
      else {
        TradeCapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExTrade << "    Yr" << T << ".N" << count << " = " << CapCostTrade[count] << "," << endl ;
      } 
    } ;

	    if (T <= NT - Aquif2InvLag) {
	  CapCostAquif2[count] = TrAquif2InvC[T]*Cp[count] ;
      if (count == 1) {
        Aquif2CapInv <<"  / Yr" << T << ".N" << count << "," << endl ;
        CapExAquif2 << "  / Yr" << T << ".N" << count << " = " << CapCostAquif2[count] << "," << endl ;
      } 
      else if (count == cumnat[NT-Aquif2InvLag]) {
        Aquif2CapInv <<"    Yr" << T << ".N" << count << " / ;" << endl ;
        CapExAquif2 << "    Yr" << T << ".N" << count << " = " << CapCostAquif2[count] << " / ;" << endl ;
      } 
      else {
        Aquif2CapInv <<"    Yr" << T << ".N" << count << "," << endl ;
        CapExAquif2 << "    Yr" << T << ".N" << count << " = " << CapCostAquif2[count] << "," << endl ;
      } 
    } ;


    for (K=1; K<=L; K++) {
      AggQtyQd[count][K] = (PriceLin[K] - Alpha[T])/Beta[T] ;
      AggAreaQd[count][K] =
        (Alpha[T]*AggQtyQd[count][K] + 0.5*Beta[T]*AggQtyQd[count][K]*AggQtyQd[count][K])*Df[T]*Cp[count] ;
      //
      // Write records to file AggArea and AggQty
      //
      if (count == 1 && T == 1 && K == 1) {
        AggDprice <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << "," << endl ;
        AggArea <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << "," << endl ;
        AggQty <<"  / Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << "," << endl ;
      } 
      else if (count == NNodes && T == NT && K == L) {
        AggDprice <<"    Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << " / ;" << endl ;
        AggArea <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << " / ;" << endl ;
        AggQty <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << " / ;" << endl ;
      } 
      else{
        AggDprice <<"    Yr" << T << ".N" << count << ".L" << K << " = " << PriceLin[K] << "," << endl ;
        AggArea <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggAreaQd[count][K] << "," << endl ;
        AggQty <<"    Yr" << T << ".N" << count << ".L" << K << " = " << AggQtyQd[count][K] << "," << endl ;
      } ;
    } ;
    for (J=1; J<=D; J++) {
      for (K=1; K<=L; K++) {
        QtyQd[count][J][K] = (PriceLin[K] - alin[J])/bglin[T][J] ;
        AreaQd[count][J][K] =
          (alin[J]*QtyQd[count][J][K] + 0.5*bglin[T][J]*QtyQd[count][J][K]*QtyQd[count][J][K])*Df[T]*Cp[count] ;
        //
        // Write records to file Area and Qty
        //
        if (count == 1 && J ==1 && K == 1) {
          Dprice <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << "," << endl ;
          Area <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << "," << endl ;
          Qty <<"  / Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << "," << endl ;
        } 
        else if (count == NNodes && J == D && K == L) {
          Dprice <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << " / ;" << endl ;
          Area <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << " / ;" << endl ;
          Qty <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << " / ;" << endl ;
        } 
        else{
          Dprice <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << PriceLin[K] << "," << endl ;
          Area <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << AreaQd[count][J][K] << "," << endl ;
          Qty <<"    Yr" << T << ".N" << count << ".D" << J << ".L" << K << " = " << QtyQd[count][J][K] << "," << endl ;
        } ;
      } ;
    } ;

  if (T == NT) {             /* do the following calculations for nodes in the last year  */
    for (K=1; K<=M; K++) {
      PriceTS[count][K] = bTS*QtyTSLin[K] + aTS;
      AreaQdTS[count][K] =
        (0.5*bTS*pow(QtyTSLin[K],2) + aTS*QtyTSLin[K] - 0.5*bTS*12100 - aTS*110) *Df[T]*Cp[count]*gf[T]/(1+discount)  ;
	  if (QtyTSLin[K] < 155.5) {
		   RestTerm[K] = 1.5332*QtyTSLin[K] + 5526.4 ;
	  } ;
	  AreaQdTSRest[count][K] = ((0.5*bTS*pow(QtyTSLin[K],2) + aTS*QtyTSLin[K] - 0.5*bTS*12100 - aTS*110) - RestTerm[K]) *Df[T]*Cp[count]*gf[T]/(1+discount) ;
      //
      // Write records to file AreaTS, PriceLinTS, QtyTS and AreTSRest
      //
      if (count == cumnat[T-1] + 1 && T == NT && K == 1) {
        AreaTS <<"  / Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTS[count][K] << "," << endl ;
        QtyTS <<"  / Yr" << T << ".N" << count << ".M" << K << " = " << QtyTSLin[K] << "," << endl ;
		PriceLinTS <<"  / Yr" << T << ".N" << count << ".M" << K << " = " << PriceTS[count][K] << "," << endl ;
		AreaTSRest <<"  / Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTSRest[count][K] << "," << endl ;
      } 
      else if (count == NNodes && T == NT && K == M) {
        AreaTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTS[count][K] << " / ;" << endl ;
        QtyTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << QtyTSLin[K] << " / ;" << endl ;
		PriceLinTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << PriceTS[count][K] << " / ;" << endl ;
        AreaTSRest <<"    Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTSRest[count][K] << " / ;" << endl ;
      } 
      else{
        AreaTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTS[count][K] << "," << endl ;
        QtyTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << QtyTSLin[K] << "," << endl ;
		PriceLinTS <<"    Yr" << T << ".N" << count << ".M" << K << " = " << PriceTS[count][K] << "," << endl ;
        AreaTSRest <<"    Yr" << T << ".N" << count << ".M" << K << " = " << AreaQdTSRest[count][K] << "," << endl ;
      } ;
    } ;
  } ;

    //
    //  write records to file CapMaxMap
    //
    if (T == NT-DesalInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          DesalCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          DesalCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          DesalCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-AquifInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          AquifCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          AquifCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          AquifCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-RecycInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          RecycCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          RecycCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          RecycCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-TanksInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          TanksCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          TanksCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TanksCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-TradeInvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          TradeCapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          TradeCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TradeCapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
    if (T == NT-Aquif2InvLag) {
      for (TT = 1; TT <= T; TT++) {
        if (TT < T) {
          J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        }
        else if (TT == T) {
          J = count ;
        } ;
        if (count == cumnat[T-1] + 1 && TT == 1) {
          Aquif2CapMaxMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (count == cumnat[T] && TT == T) {
          Aquif2CapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          Aquif2CapMaxMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;

    //
    //  write records to file LastYrNd
    //
    if (count == cumnat[NT-1] + 1) {
      LastYrNd <<"  / Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count > cumnat[NT-1] + 1 && count < NNodes) {
      LastYrNd <<"    Yr" << T << ".N" << count << "," << endl ;
    } 
    else if (count == NNodes) {
      LastYrNd <<"    Yr" << T << ".N" << count << " / ;" << endl ;
    } ;
    //
    //  write records to file DesalScenMapSas and ScenMapSas
    //
    if (count > cumnat[NT-1]) {
      // DesalScenMapSas
      for (TT = 1; TT <= T-DesalInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + DesalInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            DesalScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // AquifScenMapSas
      for (TT = 1; TT <= T-AquifInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + AquifInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            AquifScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // RecycScenMapSas
      for (TT = 1; TT <= T-RecycInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + RecycInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            RecycScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // TanksScenMapSas
      for (TT = 1; TT <= T-TanksInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + TanksInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            TanksScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // TradeScenMapSas
      for (TT = 1; TT <= T-TradeInvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + TradeInvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            TradeScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;
      // Aquif2ScenMapSas
      for (TT = 1; TT <= T-Aquif2InvLag; TT++) {
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        for (TTT = TT + Aquif2InvLag; TTT <= T; TTT++) {
          K = long(long long ((NodeAT[count] - 1))*long long(nat[TTT])/long long(nat[T])) + 1 + cumnat[TTT-1] ;
            Aquif2ScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << "  Yr" << TTT << "  N" << K << endl ;
        } ;
      } ;

	  // ScenMap and ScenMapSas
      for (TT = 1; TT <= NT; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
        ScenMapSas << "Yr" << TT << "  N" << J << "  Yr" << T << "  N" << count << endl ;
		  if (count == cumnat[T-1] + 1 && TT == 1) {
			  ScenMap << "  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
		  }
		  else if (count == cumnat[T] && TT == T) {
			  ScenMap << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "/" <<endl ;
		  }
		  else {
			  ScenMap << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  } ;
      } ;
    } ;

	   //AquiAvgMap
	if (T <= MAvg && T>=MAvg-3) {
      for (TT = 1; TT <= T; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
		  if (count == cumnat[T-1] + 1 && T==1 && TT == 1) {
			  AquiAvgMap1 << "  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
		  }
		  else {
			  AquiAvgMap1 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  }
      } ;
	} 
	else if (T > MAvg) {
      for (TT = T-MAvg+1; TT <= T; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
		  if (count == cumnat[NT] && TT == T) {
			  AquiAvgMap1 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "/" << endl ;
		  }
		  else {
			  AquiAvgMap1 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  }
      } ;
	} ;

	if (T == NT) {
      for (TT = T - (MAvg - 1) + 1 ; TT <= NT; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
		  if (count == cumnat[T-1] + 1 && TT==NT-(MAvg-1)+1) {
			  AquiAvgMap2 << "  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
		  }
	      else if (count == cumnat[NT] && TT == T) {
			  AquiAvgMap2 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "/" << endl ;
		  }
		  else {
			  AquiAvgMap2 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  }
      } ;
      for (TT = T - (MAvg - 2) + 1 ; TT <= NT; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
		  if (count == cumnat[T-1] + 1 && TT==NT-(MAvg-2)+1) {
			  AquiAvgMap3 << "  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
		  }
	      else if (count == cumnat[NT] && TT == T) {
			  AquiAvgMap3 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "/" << endl ;
		  }
		  else {
			  AquiAvgMap3 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  }
      } ;
       for (TT = T - (MAvg - 3) + 1 ; TT <= NT; TT++) {
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
		  if (count == cumnat[T-1] + 1 && TT==NT- 1) {
			  AquiAvgMap4 << "  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
		  }
	      else if (count == cumnat[NT] && TT == T) {
			  AquiAvgMap4 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "/" << endl ;
		  }
		  else {
			  AquiAvgMap4 << "    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," <<endl ;
		  }
      } ;
	} ;




    //
    // write records to files ProdnYrNd, OpEx and CapMap
    //

	if (T > desal2lag) {
      VarCostDesal2[count] = Df[T]*Cp[count]*(utcdam+vcdesal2) ;
      if (count == cumnat[desal2lag] + 1) {
        Desal2ProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal2 << "  / Yr" << T << ".N" << count << " = " << VarCostDesal2[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        Desal2ProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExDesal2 << "    Yr" << T << ".N" << count << " = " << VarCostDesal2[count] << " / ;" << endl ;
      } 
      else {
        Desal2ProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal2 << "    Yr" << T << ".N" << count << " = " << VarCostDesal2[count] << "," << endl ;
      } ;
    } ;

	if (T > DesalInvLag) {
      VarCostDesal[count] = Df[T]*Cp[count]*(utcdam+vcdesal) ;
      CapCostDesal[count] = Cp[count]*TrdesalInvC[T] ;
      if (count == cumnat[DesalInvLag] + 1) {
        DesalProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal << "  / Yr" << T << ".N" << count << " = " << VarCostDesal[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        DesalProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExDesal << "    Yr" << T << ".N" << count << " = " << VarCostDesal[count] << " / ;" << endl ;
      } 
      else {
        DesalProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExDesal << "    Yr" << T << ".N" << count << " = " << VarCostDesal[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-DesalInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == DesalInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          DesalCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - DesalInvLag) {
          DesalCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          DesalCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > AquifInvLag) {
      VarCostAquif[count] = Df[T]*Cp[count]*(utcdam+vcaquif) ;
      CapCostAquif[count] = Cp[count]*TraquifInvC[T] ;
      if (count == cumnat[AquifInvLag] + 1) {
        AquifProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif << "  / Yr" << T << ".N" << count << " = " << VarCostAquif[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        AquifProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExAquif << "    Yr" << T << ".N" << count << " = " << VarCostAquif[count] << " / ;" << endl ;
      } 
      else {
        AquifProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif << "    Yr" << T << ".N" << count << " = " << VarCostAquif[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-AquifInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == AquifInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          AquifCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - AquifInvLag) {
          AquifCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          AquifCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > RecycInvLag) {
      VarCostRecyc[count] = Df[T]*Cp[count]*(utcdam+vcrecyc) ;
      CapCostRecyc[count] = Cp[count]*TrrecycInvC[T] ;
      if (count == cumnat[RecycInvLag] + 1) {
        RecycProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExRecyc << "  / Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        RecycProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExRecyc << "    Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << " / ;" << endl ;
      } 
      else {
        RecycProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExRecyc << "    Yr" << T << ".N" << count << " = " << VarCostRecyc[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-RecycInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == RecycInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          RecycCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - RecycInvLag) {
          RecycCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          RecycCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > TanksInvLag) {
      VarCostTanks[count] = Df[T]*Cp[count]*(utcdam+vctanks) ;
      CapCostTanks[count] = Cp[count]*TrtanksInvC[T] ;
      if (count == cumnat[TanksInvLag] + 1) {
        TanksProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExTanks << "  / Yr" << T << ".N" << count << " = " << VarCostTanks[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        TanksProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExTanks << "    Yr" << T << ".N" << count << " = " << VarCostTanks[count] << " / ;" << endl ;
      } 
      else {
        TanksProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExTanks << "    Yr" << T << ".N" << count << " = " << VarCostTanks[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-TanksInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = long(long long ((NodeAT[count] - 1)) * long long (nat[TT]) / long long (nat[T])) + 1 + cumnat[TT-1] ;
        if (T == TanksInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          TanksCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - TanksInvLag) {
          TanksCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TanksCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > TradeInvLag) {
      VarCostTrade[count] = Df[T]*Cp[count]*(utcdam+TradePrNd[count]) ; 
      CapCostTrade[count] = Cp[count]*TrtradeInvC[T] ;
      if (count == cumnat[TradeInvLag] + 1) {
        TradeProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExTrade << "  / Yr" << T << ".N" << count << " = " << VarCostTrade[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        TradeProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExTrade << "    Yr" << T << ".N" << count << " = " << VarCostTrade[count] << " / ;" << endl ;
      } 
      else {
        TradeProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExTrade << "    Yr" << T << ".N" << count << " = " << VarCostTrade[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-TradeInvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == TradeInvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          TradeCapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - TradeInvLag) {
          TradeCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          TradeCapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;
	if (T > Aquif2InvLag) {
      VarCostAquif2[count] = Df[T]*Cp[count]*(utcdam+vcAquif2) ;
      CapCostAquif2[count] = Cp[count]*TrAquif2InvC[T] ;
      if (count == cumnat[Aquif2InvLag] + 1) {
        Aquif2ProdnYrNd << "  / Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif2 << "  / Yr" << T << ".N" << count << " = " << VarCostAquif2[count] << "," << endl ;
      } 
      else if (count == NNodes) {
        Aquif2ProdnYrNd << "    Yr" << T << ".N" << count << " / ;" << endl ;
        OpExAquif2 << "    Yr" << T << ".N" << count << " = " << VarCostAquif2[count] << " / ;" << endl ;
      } 
      else {
        Aquif2ProdnYrNd << "    Yr" << T << ".N" << count << ","  << endl ;
        OpExAquif2 << "    Yr" << T << ".N" << count << " = " << VarCostAquif2[count] << "," << endl ;
      } ;
      for (TT = 1; TT <= T-Aquif2InvLag; TT++) {  /* Loop over time periods earlier than the time period for the current node */
        J = (NodeAT[count] - 1)*nat[TT]/nat[T] + 1 + cumnat[TT-1] ;
        if (T == Aquif2InvLag + 1 && count == cumnat[T-1] + 1 && TT == 1) {
          Aquif2CapMap <<"  / Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        }
        else if (T == NT && count == cumnat[NT] && TT == NT - Aquif2InvLag) {
          Aquif2CapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << " / ;" << endl ;
        }
        else {
          Aquif2CapMap <<"    Yr" << T << ".N" << count << ".Yr" << TT << ".N" << J << "," << endl ;
        } ;
      } ;
    } ;

  } ; /* End of the main FOR loop over I (Nodes at time T) */
} ; /* End of the main FOR loop over time [T] */
cout <<"All done!" << endl ;
EndTime = clock() ;
CreateGamsCode << "Finish time " << EndTime/CLK_TCK << endl ;
CreateGamsCode << "Elapsed time " << (EndTime-StartTime)/CLK_TCK << endl ;
}  /* End of the main program */



